#!tclsh7.5
# This is an experimental script for running objGet from the shell.
if {$argc < 3} {
    puts "usage: imgop.tcl op image output"
    puts "e.g. imgop.tcl ohta.boa db/bt/view/image/001 db/bt/view/ohta/001"
    exit
}
load_boa
# for procs.c
load-libs region$build
# for sar.c
load-libs f2c blas lapack
boa pkg vector

# read the operator (a contextProc)
set od [boa create [boa type objDir]]
set op [boa get $od [lindex $argv 0]]
boa print $op

# read the image
set img [boa get $od [lindex $argv 1]]

# perform the operation
set result [boa objGet $op $img]
boa free $op

if 0 {
    # save the result
    boa set $od [lindex $argv 2] $result
} else {
    # run it through MCI
    set mci [boa get $od lib/common/mci.boa]
    set t [boa objGet $mci $result]
    boa free $result
    set mean [boa get $t mean]
    boa set $od [lindex $argv 2] $mean
    if {$argc > 3} {
	set icov [boa get $t icov]
	boa set $od [lindex $argv 3] $icov
    }
    boa free $t
}
boa free $od
