# computes the search result for each line on stdin
if {$argc < 3} {puts stderr "usage: wish4.1 results.tcl db metric n < queries"; exit 1}
unpack $argv dbn metric n
load_ph

set od [boa create [boa type objDir]]
set dbs [boa get $od $env(PHOTOBOOK_DB_DIR)]
boa free $od
set db [boa get $dbs $dbn]
set cache [boa get $db cache]
set index [boa get $cache index]
boa tcl_var [boa hold $index] ws
#puts stderr $ws

set features [boa get $cache feature]
set metric [boa get $cache metric/$metric]
boa set $metric features $features

if {[boa typeof [boa typeof $index]] != [boa type array]} {
    #puts stderr "converting to array"
    set tests [boa parse tcl [boa parse type 0 "(array [llength $ws] string)"] \{$ws\}]	
} else {
    set tests [boa hold $index]
}
boa set $metric test $tests

proc query {query} {
    global metric n ws index

    boa tcl_var [boa hold $index] ws
    boa tcl_var [boa getu $metric $query] dists
    sort -real dists ws
    flush stderr
    return [lrange $ws 0 $n]
}

while {[gets stdin line] >= 0} {
    puts stderr $line
    puts [query $line]
}

exit
