# start on ruislip with:
# source sourceme
# tclsh7.5 bin/common/server.tcl >& /tmp/tpminka/server.log &
load_ph
#load-libs tpm$build array$build boa$build learn$build
#boa pkg vector

proc query {dbn metric query n} {
    global dbs
    puts stderr "$dbn $metric $query $n"

    # get list of databases
    boa tcl_var [boa get $dbs database_list] databases
    #puts stderr $databases

    if {$dbn == ""} {
	set dbn [lindex $databases 0]
    } else {
	if {[lsearch -exact $databases $dbn] < 0} {
	    return -code 1 "Unknown database"
	}
    }

    set db [boa get $dbs $dbn]
    set cache [boa get $db cache]
    set index [boa get $cache index]
    boa hold $index
    boa tcl_var $index ws
    #puts stderr $ws

    # get list of metrics
    if {[catch {boa tcl_var [boa get $db metric_list] metrics}]} {
	# no metrics; just shuffle
	set query ""
	set metrics ""
    }
    #puts stderr $metrics

    # metric(members = $members, query = $query, test = $tests)
    if {$metric == ""} {
	set metric [lindex $metrics 0]
    }
    if {$query != "" && ![catch {set features [boa get $cache feature]}]} {
	set args [boa get $cache metric/$metric]

	boa set $args features $features
	if {[boa typeof [boa typeof $index]] != [boa type array]} {
	    #puts stderr "converting to array"
	    set tests [boa parse tcl [boa parse type 0 "(array [llength $ws] string)"] \{$ws\}]	
	} else {
	    set tests [boa hold $index]
	}
	#boa print $tests
	boa set $args test $tests

	#puts stderr "->metric"
	boa tcl_var [boa getu $args $query] dists
        #puts stderr "<-metric"
	boa free $args
    } else {
	# shuffle
	set dists ""
	#puts stderr "->shuffle"
	foreach m $ws {
	    lappend dists [ran]
	}
	#puts stderr "<-shuffle"
    }
    boa free $index
    boa free $cache
    boa free $db
    #puts stderr "->sort"
    sort -real dists ws
    #puts stderr "<-sort"
    flush stderr
    return [list [lrange $ws 0 $n] $metrics $databases]
}

proc init {} {
    global dbs
    if [info exists dbs] {boa free $dbs}
    set od [boa create [boa type objDir]]
    set dbs [boa get $od "db_cache.boa"]
    boa free $od
}
init

###############################################################################
set port 2828

proc serve {chan host port} {
    set cmd [gets $chan]
    # only allow the "query" command
    if {[llength $cmd] > 0} {
	if {[lindex $cmd 0] == "init"} {
	    init
	} elseif {[lindex $cmd 0] == "query"} {
	    if {[catch {puts $chan [eval $cmd]} msg]} {
		puts stderr $msg
	    }
	} else {
	    puts stderr "bad command: $cmd"
	}
    } else {
	puts stderr "empty command"
    }
    close $chan
}

set chan [socket -server serve $port]
vwait forever
