#!tclsh7.5
if {$argc < 2} {
    puts stderr "Usage: db within < index"
    puts stderr "To generate a combined index for all members on stdin"
    puts stderr "which use the `within' hier."
    puts stderr "E.g. ls -1 view/image | within_index bt 8x8 > 8x8.index"
    exit
}
unpack $argv db within

load_ph
set od [boa create [boa type objDir]]

set od [boa get $od $env(PHOTOBOOK_DB_DIR)/$db/within/$within]

puts "BOA index\nindex\n\{"
while {[gets stdin member] > 0} {
    if {[catch {set hier [boa get $od $member]}]} {continue}
    puts stderr $member
    boa tcl_var [boa intGet [boa typeof $hier] 0] length
    boa free $hier
    for {set i 0} {$i < $length} {incr i} {
	puts $within/$member/$i
    }
}
puts \}
exit
