#include <boa/boa.h>
#include "segmask.h"
#include <tpm/list.h>
#include <tpm/hier.h>
#include <boa/image.h>
#include <boa/vector.h>

typedef struct {
  int children, parent;
  Seg seg;
} WithinNode;

typedef struct {
  int children, parent;
  int within,    /* which within-hier this node occurs in */
      member,    /* which member this node belongs to */
      segment;   /* which segment in the member's within-hier */
} AcrossNode;

/* data part of AcrossNode */
typedef struct {
  int within, member, segment;
} AcrossData;

/* within.c ******************************************************************/
void Ph_WithinInit(Obj within, List within_list);
void Ph_WithinDestroy(void);
void Ph_WithinSave(void);
void Ph_WithinClear(void);
Seg Ph_WithinGet(void);
void Ph_WithinEx(int x, int y, float weight);
int Ph_WithinBench(Seg *seg);

/* across.c ******************************************************************/
void Ph_AcrossInit(Obj members, Obj across, List across_list, 
		   Obj within, List within_list);
void Ph_AcrossDestroy(void);
void Ph_AcrossEnable(int tree, int flag);
List Ph_AcrossGet(int member, int label);
Seg Ph_AcrossSeg(int member, int label);
void Ph_AcrossEx(int member, int label, Seg *seg, float weight);
