/* Generate a cophenetic nearest-neighbor matrix for a tree.
 * Ties are resolved at random.
 * Leaf indices start at 0.
 */
#include <tpm/gtree.h>

#if 0
void TreeWriteLeaves(FILE *fp, Tree tree, WriteFunc *pf)
{
  if(!tree) return;
  if(tree->child) {
    IterateChildren(tree, child) {
      TreeWriteLeaves(fp, child, pf);
    }
  }
  else { pf(fp, tree->data); fprintf(fp, " "); }
}
#endif

main()
{
  Tree tree = TreeRead(stdin, IntRead);
  List leaves = TreeLeafList(tree);
  int i,j, leaf_count = ListSize(leaves);
  Tree *leaf = Allocate(leaf_count, Tree);
  Tree t, last_t;

  {ListIter(p, t, leaves) {
    leaf[*(int*)t->data] = t;
  }}
  ListFree(leaves);

  srand(time(NULL));
  for(i=0;i<leaf_count;i++) {
    last_t = leaf[i];
    printf("%d ", i);
    for(t = last_t->parent; t; t = last_t->parent) {
      leaves = ListCreate(NULL);
      {IterateChildren(t, child) {
	if(child == last_t) continue;
	ListAppend(leaves, TreeLeafData(child));
      }}
      ListShuffle(leaves);
      ListPrint(stdout, leaves, IntWrite);
      ListFree(leaves);

      last_t = t;
    }
    printf("\n");
  }
  free(leaf);
  TreeFree(tree, GenericFree);
  MEM_STATUS();
  MEM_BLOCKS();
  exit(0);
}

