# Generate a nearest-neighbor file from a list of vectors
BEGIN {
  len = 2
  dist_thres = 1000
}
{
  for(i=1;i<=len;i++)
    vector[NR,i] = $i
}
END {
  for(i=1;i<=NR;i++) {
    # compute distance to every other point
    n = 1
    for(j=1;j<=NR;j++) {
      distance[n] = 0
      for(k=1;k<=len;k++) {
        dist = vector[i,k] - vector[j,k]
	distance[n] += dist*dist
      }
      distance[n] = sqrt(distance[n])
      printf "%g ", distance[n]
      n++     
    }
    printf "\n"
  }
}
