/* Removes the top level of a tree by merging all children of the root.
 */

#include <tpm/gtree.h>

Tree MergeTop(Tree tree);

void main(int argc, char *argv[])
{
  FILE *fp;
  Tree tree;

  if(argc < 2) {
    printf("Usage: %s <tree>\n", argv[0]);
    exit(0);
  }

  fp = SafeOpen(argv[1], "r");
  tree = TreeRead(fp, RealRead);
  fclose(fp);

  TreeWrite(stdout, MergeTop(tree), RealWrite);
}

Tree TreeCopy(Tree tree, void *dummy)
{
  Tree result;
  if(!tree) return NULL;
  result = TreeCreate(tree->data);
  {IterateChildren(tree, child) {
    TreeAddChild(result, TreeCopy(child, dummy));
  }}
  return result;
}

Tree MergeTop(Tree tree)
{
  Tree result;

  result = TreeCreate(tree->data);
  {IterateChildren(tree, child) {
    if(TreeLeaf(child)) TreeAddChild(result, TreeCreate(child->data));
    else {
      {IterateChildren(child, nextchild) {
	TreeAddChild(result, TreeCopy(nextchild, NULL));
      }}
    }
  }}
  return result;
}
