# Generate a nearest-neighbor file from a list of vectors
BEGIN {
  len = 2
  dist_thres = 1000
}
{
  for(i=1;i<=len;i++)
    vector[NR,i] = $i
}
END {
  for(i=1;i<=NR;i++) {
    # compute distance to every other point
    n = 1
    for(j=1;j<=NR;j++) {
      distance[n] = 0
      for(k=1;k<=len;k++) {
        dist = vector[i,k] - vector[j,k]
	distance[n] += dist*dist
      }
      distance[n] = sqrt(distance[n])
      n++     
    }

    # print points with dist_thres smallest distances
    for(j=0;j<dist_thres;j++) {
      if(j > NR) break
      best = 1e6
      best_i = 0
      for(k=1;k<=NR;k++) {
        if(distance[k] < best) {
          best = distance[k]
          best_i = k
        }
      }
      if(best_i == 0) break
      printf "%d ",best_i-1
      distance[best_i] = 1e6
    }
    printf "\n"
  }
}
