#include <tpm/partition.h>

void main(int argc, char *argv[])
{
  Partition p1, p2;
  FILE *fp;
  int num_elts;

  if(argc < 4) {
    printf("%s <num_elts> <partition_1> <partition_2>\n", argv[0]);
    printf("To compute the corrected Rand index between two partitions.\n");
    printf("num_elts = number of elements in each partition for comparision\n");
    printf("partition_n = name of partition file\n");
    exit(0);
  }

  num_elts = atoi(argv[1]);

  fp = fopen(argv[2], "r");
  if(!fp) {
    printf("Cannot open `%s'\n", argv[2]);
    exit(1);
  }
  p1 = ReadPartition(fp, num_elts);
  fclose(fp);

  fp = fopen(argv[3], "r");
  if(!fp) {
    printf("Cannot open `%s'\n", argv[3]);
    exit(1);
  }
  p2 = ReadPartition(fp, num_elts);
  fclose(fp);

  printf("%lg\n", RandIndex(p1, p2));
}
