BEGIN {
  if(ARGC < 2) {
    print "Usage: ranks1 ranks2"
    print "To compute Kendall's rank correlation betw every pair of lines"
    exit
  }
  file2 = ARGV[--ARGC]
}
{
  split($0, rank1)
  getline < file2
  split($0, rank2)

# values must start at 1, not 0, for AWK
  for(i in rank1) rank1[i]++
  for(i in rank2) rank2[i]++
  
  invert(rank2, p)
  compose(p, rank1, rank2)

#  for(i=1;i<=NF;i++) printf "%d ", rank2[i]
  n = NF
  print rank_corr(rank2)
}
function invert(p, dest)
{
  for(i in p) dest[p[i]] = i+0
}
function compose(p, q, dest)
{
  for(i in p) dest[i] = q[p[i]]
}
function rank_corr(p)
{
  if(1) {
# Bhat
    if(1) {
# This is the fast alg given in the paper
      for(i in p) { ind[p[i]] = i+0 }
      max = cur = 0
      for(i=1;i<=n;i++) {
	if(ind[i] < i) cur--
	if(p[i] > i) {
	  cur++
          if(cur > max) max = cur
	}
	count[i] = cur
      }
#      for(i=1;i<=n;i++) printf "%d ", count[i]
    } else {
      for(i in p) { count[i] = 0 }
      for(i in p) {
	for(j=i+0;j<p[i];j++) count[j]++
      }
#      for(i=1;i<=n;i++) printf "%d ", count[i]
      max = 0
      for(i in p) {
        if(count[i] > max) max = count[i]
      }
    }
    return 1 - 2 * max / int(n/2)
  } else {
# Kendall
    sum = 0
    for(i in p) {
      for(j=1;j<i+0;j++) if(p[j] > p[i]) sum++
    }
    return 1 - 2 * sum / (n*(n-1)/2)
  }
}
