#!/usr/local/bin/wish -f
# <nn_file> <nsamples> <rows> <kt>

if {[llength $argv] < 4} {puts "Usage: <nn_file> <nsamples> <rows> <kt>";exit} 
set nnfile [lindex $argv 0]
set nsamples [lindex $argv 1]
set rows [lindex $argv 2]
set cols [expr $nsamples/$rows]
set kt [lindex $argv 3]

# make grid of labels
for {set row 0} {$row < $rows} {incr row} {
  # make a frame for this row
  frame .row$row
  pack .row$row -fill x
  for {set col 0} {$col < $cols} {incr col} {
#    set patch .patch[expr $cols*$row+$col]
    set patch .patch[expr $col*$rows+$row]
    label $patch -height 1 -width 3
    pack $patch -in .row$row -side left
  }
}

set k 50

proc do_clus {k} {
  global nnfile nsamples kt
  if {$k < $kt} return
  set fid [open "|/mas/vision/projects/photobook/bin/hp700/nncluster $nnfile $nsamples $k $kt"]
  while 1 {
    set line [gets $fid]
    if {[eof $fid]} break
    lappend partition $line
  }
  close $fid

  # fill in the grid
  for {set i 0} {$i < $nsamples} {incr i} {
    .patch$i configure -text [lindex $partition $i]
  }
}

scale .ks -orient horiz -to 127 -command do_clus
pack .ks -fill x
.ks set $k

entry .e -text $k
pack .e -fill x
bind .e <Return> {.ks set [.e get]}
