#ifndef BOA_H_INCLUDED
#define BOA_H_INCLUDED

#include <boa/type.h>
#include <boa/std.h>
#include <boa/error.h>

/* globals *******************************************************************/
extern Obj Boa_Types, Boa_Formatters, Boa_Globals;

/* boa.c *********************************************************************/
void Boa_Startup(void);
void Boa_Shutdown(void);

int BoaCompare(Obj a, Obj b);
int BoaHash(Obj t);
char *Boa_AsString(Obj t);
int Boa_Print(FILE *fp, Obj t);
int Boa_PrintNL(FILE *fp, Obj t);
Obj Boa_GetFormatter(char *name);
int Boa_StringGetInt(Obj context, char *name, int *value_return);
int Boa_IntGetInt(Obj context, int index, int *value_return);
int Boa_ObjGetInt(Obj context, Obj index, int *value_return);

Type Boa_Type_VaCreate(Type type, ...);
Type Boa_Type_Create(char *name);
int Boa_Type_Compatible(Type ref, Type test);

/* stream.c ******************************************************************/
int Boa_Tell(Obj stream);
int Boa_Seek(Obj stream, int pos, int whence);
char *Boa_TellString(Obj stream);
int Boa_SeekString(Obj stream, char *pos);

int Boa_Getc(Obj stream);
char *Boa_GetLine(Obj stream);
int Boa_Scan(Obj stream, Obj value);

int Boa_Putc(Obj stream, char c);
int Boa_Puts(Obj stream, char *s);

/* macros ********************************************************************/

#define BOA_TYPECHECK_GET(type) \
if(type_in_out) {                                  \
  if(!*type_in_out) *type_in_out = type;           \
  else if(Boa_Compare(*type_in_out, type)) return TPM_BOTTOM; \
} else

#endif
