typedef Obj Boa_DefineFunc(void);
typedef void Boa_PkgFunc(void);

/* stype *********************************************************************/
Boa_DefineFunc Boa_SimpleType_Define;
extern Type T_SimpleType;
Type Boa_SimpleType_Create(char *name, Boa_Methods methods, 
			   int size, int align);

/* ptype *********************************************************************/
Boa_DefineFunc Boa_ParamType_Define;
extern Type T_ParamType;
Type Boa_ParamType_Create(char *name, Boa_InitFunc *init,
			  int num_args, ...);

typedef struct Boa_ParamType {
  TYPE_HEAD
  int num_args;
  Type *unknown;
  Obj *known;
  Obj parent;
} *Boa_ParamType;

typedef struct Boa_ParamTypeInstance {
  TYPE_HEAD
  int num_args;
  Obj *args;
} *Boa_ParamTypeInstance;
#define Boa_PType_Item(t, i) ((Boa_ParamTypeInstance)(t)->value)->args[i]

/* int ***********************************************************************/
Boa_DefineFunc Boa_Int_Define;
extern Type T_Int;
#define Boa_Int_Value(t) ((int*)(t)->value)[0]
Obj Boa_Int_Create(int i);

/* float *********************************************************************/
Boa_DefineFunc Boa_Float_Define;
extern Type T_Float;
#define Boa_Float_Value(t) ((float*)(t)->value)[0]
Obj Boa_Float_Create(float f);

/* double ********************************************************************/
Boa_DefineFunc Boa_Double_Define;
extern Type T_Double;
#define Boa_Double_Value(t) ((double*)(t)->value)[0]
Obj Boa_Double_Create(double d);

/* char **********************************************************************/
Boa_DefineFunc Boa_Char_Define;
extern Type T_Char;
#define Boa_Char_Value(t) ((char*)(t)->value)[0]
Obj Boa_Char_Create(char c);

/* string ********************************************************************/
Boa_DefineFunc Boa_String_Define;
extern Type T_String;
#define Boa_String_Value(t) ((char**)(t)->value)[0]
Obj Boa_String_Create(char *s);
Obj Boa_String_00(char **s);
Obj Boa_String_01(char *s);

/* ptr ***********************************************************************/
Boa_DefineFunc Boa_Ptr_Define;
extern Type T_Ptr;
#define Boa_Ptr_Value(t) ((Ptr*)(t)->value)[0]
Obj Boa_Ptr_Create(Ptr p);

/* dict **********************************************************************/
Boa_DefineFunc Boa_Dict_Define;
extern Type T_Dict;

/* obStruct ******************************************************************/
Boa_DefineFunc Boa_ObStruct_Define;
extern Type T_ObStruct;
#define Boa_ObStruct_Data(t) ((void**)(t)->value)[0]

/* array *********************************************************************/
Boa_DefineFunc Boa_Array_Define;
extern Type T_Array;
#define Boa_Array_Length(t) Boa_Int_Value(Boa_PType_Item(t, 0))
#define Boa_Array_Subtype(t) Boa_PType_Item(t, 1)

/* eval **********************************************************************/
Boa_DefineFunc Boa_Eval_Define;
extern Type T_Eval;
#define Boa_Eval_Context(t) ((Obj*)(t)->value)[0]

/* ord ***********************************************************************/
Boa_DefineFunc Boa_Ord_Define;
extern Type T_Ord;
#define Boa_Ord_Name(t, i) (*(Obj**)(t)->value)[(i)*2+1]
#define Boa_Ord_Item(t, i) (*(Obj**)(t)->value)[(i)*2]
#define Boa_Ord_Length(t) ((int*)((Ptr*)(t)->value+1))[0]

/* merge *********************************************************************/
Boa_DefineFunc Boa_Merge_Define;
extern Type T_Merge;
#define Boa_Merge_Inherit(t) ((Obj*)(t)->value)[0]

/* cache *********************************************************************/
Boa_DefineFunc Boa_Cache_Define;
extern Type T_Cache;
#define Boa_Cache_Context(t) ((Obj*)(t)->value)[0]
Obj Boa_Cache_Create(Obj context);

/* idDict ********************************************************************/
Boa_DefineFunc Boa_IdDict_Define;
extern Type T_IdDict;

/* always ********************************************************************/
Boa_DefineFunc Boa_Always_Define;
extern Type T_Always;

/* iter **********************************************************************/
Boa_DefineFunc Boa_Iter_Define;
extern Type T_Iter;
#define Boa_Iter_Data(t) ((Obj*)(t)->value)[0]
#define Boa_Iter_Indexer(t) ((Obj*)(((Obj*)(t)->value)[1]->value))[0]

/* indexer *******************************************************************/
Boa_DefineFunc Boa_Indexer_Define;
extern Type T_Indexer;
typedef int Boa_IndexerStringFunc(Obj self, char *name);
typedef Obj Boa_IndexerIntFunc(Obj self, int index);
typedef int Boa_IndexerObjFunc(Obj self, Obj index);
#define Boa_Indexer_Data(t) ((Obj*)(t)->value)[0]
#define Boa_Indexer_ObjFunc(t) ((Boa_IndexerObjFunc**)(t)->value)[1]
#define Boa_Indexer_IntFunc(t) ((Boa_IndexerIntFunc**)(t)->value)[2]

/* index *********************************************************************/
Boa_DefineFunc Boa_Index_Define;
extern Type T_Index;
#define Boa_Index_Item(t, i) (*(Obj**)(t)->value)[i]
#define Boa_Index_Length(t) ((int*)((Ptr*)(t)->value+1))[0]

/* filter ********************************************************************/
Boa_DefineFunc Boa_Filter_Define;
extern Type T_Filter;
#define Boa_Filter_Context(t) ((Obj*)(t)->value)[0]
#define Boa_Filter_StringMap(t) ((Obj*)(t)->value)[1]
#define Boa_Filter_IntMap(t) ((Obj*)(t)->value)[2]
#define Boa_Filter_ObjMap(t) ((Obj*)(t)->value)[3]

/* strStream *****************************************************************/
Boa_DefineFunc Boa_StrStream_Define;
extern Type T_StrStream;
#define Boa_StrStream_Value(t) ((StrStream*)(t)->value)[0]
Obj Boa_StrStream_FromString(char *string);

/* fileHandle ****************************************************************/
Boa_DefineFunc Boa_FileHandle_Define;
extern Type T_FileHandle;
#define Boa_FileHandle_Value(t) ((FILE**)(t)->value)[0]
Obj FileHandle_Open(char *name, char *mode);

/* objdir ********************************************************************/
Boa_DefineFunc Boa_ObjDir_Define;
extern Type T_ObjDir;
extern Obj Boa_ObjDir_DefaultFormatter;
/* read-only */
#define Boa_ObjDir_Path(t) ((char**)(t)->value)[0]

/* diskArray *****************************************************************/
Boa_DefineFunc Boa_DiskArray_Define;
extern Type T_DiskArray;
extern Obj Boa_DiskArray_DefaultFormatter;

/* formatBoa *****************************************************************/
Boa_DefineFunc Boa_FormatBoa_Define;
extern Type T_FormatBoa;
extern Obj Boa_FormatBoa_DefaultFormatters;

/* formatAscii ***************************************************************/
Boa_DefineFunc Boa_FormatAscii_Define;
extern Type T_FormatAscii;

/* formatBinary **************************************************************/
Boa_DefineFunc Boa_FormatBinary_Define;
extern Type T_FormatBinary;

/* formatArray ***************************************************************/
Boa_DefineFunc Boa_FormatArray_Define;
extern Type T_FormatArray;
extern Obj Boa_FormatArray_DefaultFormatter;

/* formatIndex ***************************************************************/
Boa_DefineFunc Boa_FormatIndex_Define;
extern Type T_FormatIndex;

/* formatDict ****************************************************************/
Boa_DefineFunc Boa_FormatDict_Define;
extern Type T_FormatDict;

/* contextProc ***************************************************************/
Boa_DefineFunc Boa_ContextProc_Define;
extern Type T_ContextProc;
/* If one return, sets *value_return to it.
 * Otherwise sets *value_return to a context of values.
 * If type_in_out == NULL, no type check is performed and no type is returned.
 * If *type_in_out == NULL, no type check, type of the result is returned.
 * If *type_in_out != NULL, returns a value matching that type.
 * Modifies: context.
 * Requires: value_return != NULL.
 */
typedef int ContextFunc(Obj context, Type *type_in_out, Obj *value_return);
#define Boa_ContextProc_Context(t) ((Obj*)(t)->value)[0]
#define Boa_ContextProc_Func(t) ((ContextFunc**)(t)->value)[1]

/* dl ************************************************************************/
Boa_DefineFunc Boa_DLOpen_Define, Boa_DLSym_Define;
extern Type T_DLOpen, T_DLSym;

/* atoi **********************************************************************/
Boa_DefineFunc Boa_Atoi_Define;
extern Type T_Atoi;

/* offset ********************************************************************/
Boa_DefineFunc Boa_Offset_Define;
extern Type T_Offset;

/* list **********************************************************************/
Boa_DefineFunc Boa_List_Define;
extern Type T_List;
#ifdef TPM_LIST_H_INCLUDED
#define Boa_List_Value(t) ((List)(t)->value)
#endif

/* tuple *********************************************************************/
Boa_DefineFunc Boa_Tuple_Define;
extern Type T_Tuple;
#define Boa_Tuple_Item(t, i) ((Obj*)(t)->value)[i]
#define Boa_Tuple_Length(t) Boa_Int_Value(Boa_PType_Item((t)->type, 0))

/* mapCon ********************************************************************/
Boa_DefineFunc Boa_MapCon_Define;
extern Type T_MapCon;
Obj Boa_MapCon_Create(Obj context);

/* debug *********************************************************************/
Boa_DefineFunc Boa_Debug_Define;
extern Type T_Debug;

/* constructMap **************************************************************/
Boa_DefineFunc Boa_ConstructMap_Define;
extern Type T_ConstructMap;

/* spanTree ******************************************************************/
Boa_DefineFunc Boa_SpanTree_Define, Boa_FormatSpanTree_Define;
extern Type T_SpanTree, T_FormatSpanTree;
#define Boa_SpanTree_Length(t) Boa_Int_Value(Boa_PType_Item(t, 0))
#define Boa_SpanTree_Value(t) ((SpanTree)(t)->value)
