#include <tpm/tpm.h>
#include <tpm/strstream.h>

/* node types */
enum {
  ST_APP, ST_NAME, ST_INT, ST_STRING
};

union ST; /* forward */

struct ST_Any {
  int node_type;
};

struct ST_Multiple {
  int node_type;
  int children;
  union ST **child;
};

struct ST_Single {
  int node_type;
  union ST *arg;
};

struct ST_Value {
  int node_type;
  Any value;
};

typedef union ST {
  struct ST_Any any;
  struct ST_Multiple m;
  struct ST_Single s;
  struct ST_Value v;
} *ST;

ST ST_Parse(StrStream ss);
void ST_Free(ST st);
void ST_Print(FILE *fp, ST st);
