# Usage: <dir>
# To browse the images in <dir>.
require boa

set rows 4
set cols 4
set total [expr $rows * $cols]

# make grid of labels
frame .grid
pack .grid -side left -fill both -expand 1
for {set row 0} {$row < $rows} {incr row} {
    for {set col 0} {$col < $cols} {incr col} {
	set index [expr $cols*$row+$col]
	# make a frame for image and label
	frame .frame$index -relief raised -borderwidth 2
        grid .frame$index -row $row -column $col -in .grid
	
	label .patch$index -image [image create photo image$index]
	label .label$index
	pack .patch$index .label$index -in .frame$index -fill x -expand 1
  }
}

if {$argc == 1} {
    set dir [lindex $argv 0]
} else {
    #set dir "/mas/vision/projects/TextureHeads/VisionTexture/photobook/data/VisTex/128x128"
    set dir $env(HOME)/smallcorel
}
cd $dir
set od [boa create [boa type objDir]]
#boa set $od _formatter [boa formatter pnm]
set names [glob *]
set start 0

proc refresh {} {
  global od start total names
  set num_images [llength $names]
  # fill in the grid
  for {set i 0} {$i < $total} {incr i} {
    set pos [expr $i + $start]
    if {$pos >= $num_images} {image$i blank; continue}
    set name [lindex $names $pos]
    .label$i configure -text $name
    boa tk_image [boa get $od $name] image$i
    update
  }
}

label .start -textvar start
pack .start

button .up -text Up -command {
  if {$start == 0} return
  if {$start > 0} {set start [expr $start - $total]}
  if {$start < 0} {set start 0}
  refresh
}
pack .up
button .down -text Down -command {
  set start [expr $start + $total]
  refresh
}
pack .down

button .quit -text Quit -command {
  boa free $od
  rename boa ""
  exit
}
pack .quit

refresh
