#define Err(e, m) if(e) { interp->result = m; return TCL_ERROR; } else
#define Try(e) if(e) { interp->result = Tcl_PosixError(interp); return TCL_ERROR; } else

#define GetInt(s, v) if(Tcl_GetInt(interp, s, (int*)&v) != TCL_OK) return TCL_ERROR; else
#define GetDouble(s, v) if(Tcl_GetDouble(interp, s, (double*)&v) != TCL_OK) return TCL_ERROR; else
#ifdef __alpha
#define GetPtr(s, v) if(Tcl_GetDouble(interp, s, (double*)&v) != TCL_OK) return TCL_ERROR; else v = (void*)(long)*(double*)&v
#else
#define GetPtr(s, v) if(Tcl_GetInt(interp, s, (int*)&v) != TCL_OK) return TCL_ERROR; else
#endif
#define GetColor(str, clr) \
  Err(!XParseColor(dpy, DefaultColormap(dpy, DefaultScreen(dpy)), str, \
		   &clr), "unknown color")
#define GetWindow(str, win) \
  Err(!(win = Tk_NameToWindow(interp, str, Tk_MainWindow(interp))), "bad window path")
#define GetChannel(str, chan) \
  if(!(chan = Tcl_GetChannel(interp, str, NULL))) return TCL_ERROR; else

#define GetPhoto(str, image) \
  if((image = Tk_FindPhoto(str)) == NULL) {               \
    Tcl_AppendResult(interp, "image \"", str,             \
		     "\" doesn't exist", (char *) NULL);  \
    return TCL_ERROR;                                     \
  }

#define ReturnInt(i) sprintf(interp->result, "%d", (int)(i))
#define ReturnFloat(d) sprintf(interp->result, "%g", (double)(d))
#define ReturnDouble(d) sprintf(interp->result, "%g", (double)(d))
#define ReturnPtr(ptr) sprintf(interp->result, "%ld", (long)(ptr))

