load-lib tpm-mc array-mc image-mc boa-mc
require boa

boa vm vm

set gensym_count 0
proc gensym {} {
  global gensym_count
  return sym[incr gensym_count]
}

proc multi_yview args {
    set widgets [lindex $args 0]
    set cmd [lrange $args 1 end]
    foreach w $widgets {
      eval $w yview $cmd
    }
}
proc scroll_multi_list args {
    set f .[gensym]
    frame $f
    pack $f -expand 1 -fill x
    set s .[gensym]
    scrollbar $s -command "multi_yview [list $args]"
    pack $s -side right -fill y -in $f
    foreach w $args {
	listbox $w -yscroll "$s set" -setgrid 1
	pack $w -expand 1 -fill both -side left -in $f
    }
}
scroll_multi_list .cn .cv

entry .cmd 
bind .cmd <Return> {vm exec [.cmd get]; .cmd delete 0 end; show}
pack .cmd -expand 1 -fill x

proc scroll_list w {
    set f $w{-frame}
    frame $f
    pack $f -expand 1 -fill x
    set s $w{-scroll}
    scrollbar $s -command "$w yview"
    listbox $w -yscroll "$s set" -setgrid 1
    pack $s -side right -fill y -in $f
    pack $w -expand 1 -fill both -side left -in $f
}
scroll_list .v

entry .tclcmd
bind .tclcmd <Return> {puts [eval [.tclcmd get]]; .tclcmd delete 0 end; show}
pack .tclcmd -expand 1 -fill x

proc show {} {
    global vm
    # show current context
    .cn delete 0 end
    .cv delete 0 end
    set tok [vm c 0]
    if [catch {vm start $tok}] {
	puts "Cannot display this context"
	return
    }
    while 1 {    
	set pair [vm nextvn]
	if {![llength $pair]} break
        set name [lindex $pair 0]
        set tok [lindex $pair 1]
        .cn insert end $name
        if [catch {.cv insert end [boa unparse $tok]}] {
	    .cv insert end <[boa type $tok]>
        }
        boa free $tok
	update
    }
    vm stop

    # show vstack
    .v delete 0 end
    set len [vm vlen]
    for {set i 0} {$i < $len} {incr i} {
      set tok [vm v $i]
      .v insert end [boa unparse $tok]
      boa free $tok
    }
}
show
