#include <boa/boa.h>

#define Err(str) fprintf(stderr, "--> %s\n", str)

main()
{
  Type at;
  Obj a, t, t2;
  Obj *args;

  Boa_Startup();

  at = Boa_Type_Create("(array 3 string)");
  Boa_PrintNL(stdout, at);
  Boa_PrintNL(stdout, at->type);
  Boa_PrintNL(stdout, at->type->type);
  Boa_PrintNL(stdout, at->type->type->type);

  a = Boa_Create(at);
  Boa_Print(stdout, a); putchar('\n');
  t = Boa_String_Create(strdup("two"));
  if(Boa_IntSet(a, -1, BOA_REPLACE, t) == TPM_OK) {
    Err("set(-1) didn't fail");
  }
  if(Boa_IntSet(a, 3, BOA_REPLACE, t) == TPM_OK) {
    Err("set(3) didn't fail");
  }
  if(Boa_IntSet(a, 2, BOA_REPLACE, t) != TPM_OK) {
    Err("set(2) failed");
  }
  t = Boa_String_Create(strdup("one"));
  if(Boa_IntSet(a, 1, BOA_REPLACE, t) != TPM_OK) {
    Err("set(2) failed");
  }
  Boa_PrintNL(stdout, a);

  if(Boa_IntGet(a, 2, 0, &T_String, &t2) != TPM_OK) {
    Err("get(2) failed");
  }
  if(Boa_IntGet(a, 1, 0, &T_String, &t) != TPM_OK) {
    Err("get(1) failed");
  }
  Boa_Release(a);

  Boa_PrintNL(stdout, t);
  Boa_Release(t);
  Boa_PrintNL(stdout, t2);
  Boa_Release(t);

  Boa_Shutdown();
  exit(0);
}
