#include <boa/boa.h>

main()
{
  Obj dict, cache, t;
  Boa_Startup();

  dict = Boa_Create(T_Dict);
  Boa_StringSet(dict, "a", BOA_INSERT, Boa_Int_Create(1));
  Boa_StringSet(dict, "b", BOA_INSERT, Boa_Int_Create(2));

  cache = Boa_Create(T_Cache);
  Boa_Cache_Context(cache) = dict;
  Boa_Print(stdout, cache); putchar('\n');

  /* miss */
  if(Boa_StringGet(cache, "a", 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(a) failed\n");
    exit(1);
  }
  printf("a : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  /* hit */
  if(Boa_StringGet(cache, "a", 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(a) failed\n");
    exit(1);
  }
  printf("a : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  /* miss */
  if(Boa_StringGet(cache, "b", BOA_DELETE, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(b) failed\n");
    exit(1);
  }
  printf("b : "); Boa_Print(stdout, t); putchar('\n');

  if(Boa_StringGet(cache, "b", 0, &T_Int, &t) == TPM_OK) {
    fprintf(stderr, "get(b) didn't fail\n");
    exit(1);
  }

  if(Boa_StringSet(cache, "c", BOA_INSERT, Boa_Int_Create(3)) != TPM_OK) {
    fprintf(stderr, "set(c) failed\n");
    exit(1);
  }
  Boa_Print(stdout, cache); putchar('\n');

  /* hit */
  if(Boa_StringGet(cache, "c", 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(c) failed\n");
    exit(1);
  }
  printf("c : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  Boa_Release(cache);
  Boa_Shutdown();
  exit(0);
}
