#include <boa/boa.h>

main()
{
  Obj dat, da, t;
  Obj formatter, file, dec;
  Boa_Startup();

  da = Boa_Create(Boa_Type_Create("(diskArray 3 int)"));
  if(Boa_StringSet(da, "_file", 0, Boa_String_Create(strdup("test_da.in")))
     != TPM_OK) {
    fprintf(stderr, "set(da) file failed\n");
    exit(1);
  }
  Boa_Print(stdout, da); putchar('\n');

  if(Boa_IntGet(da, 0, 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(0) failed\n");
    exit(1);
  }
  printf("0 : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  if(Boa_IntGet(da, 1, 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(1) failed\n");
    exit(1);
  }
  printf("1 : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  if(Boa_IntGet(da, 2, 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(2) failed\n");
    exit(1);
  }
  printf("2 : "); Boa_Print(stdout, t); putchar('\n');

  Boa_Int_Value(t)++;
  if(Boa_IntSet(da, 2, BOA_REPLACE, t) != TPM_OK) {
    fprintf(stderr, "set(2) failed\n");
    exit(1);
  }

  if(Boa_IntGet(da, 2, 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(2) failed\n");
    exit(1);
  }
  printf("2 : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  /* now try with names */
  file = FileHandle_Open("test_da.index", "r");
  if(!file) {
    fprintf(stderr, "cannot open index: ");
    TpmPrintError(stderr);
    exit(1);
  }
  formatter = Boa_GetFormatter("boa");
  if(Boa_ObjGet(formatter, file, 0, NULL, &t) != TPM_OK) {
    fprintf(stderr, "formatter failed reading index\n");
    exit(1);
  }
  Boa_Release(file);
  Boa_Release(formatter);
  dec = Boa_Create(T_Filter);
  Boa_Filter_Context(dec) = da;
  Boa_Filter_StringMap(dec) = t;

  if(Boa_StringGet(dec, "second", 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(second) failed\n");
    exit(1);
  }
  printf("second : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  if(Boa_StringGet(dec, "first", 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(first) failed\n");
    exit(1);
  }
  printf("first : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  if(Boa_IntGet(dec, 2, 0, &T_Int, &t) != TPM_OK) {
    fprintf(stderr, "get(2) failed\n");
    exit(1);
  }
  printf("2 : "); Boa_Print(stdout, t); putchar('\n');
  Boa_Release(t);

  Boa_Release(dec);
  Boa_Shutdown();
  exit(0);
}
