#include <boa/boa.h>

static int fact(int n)
{
  if(n == 0) return 1;
  else return n * fact(n-1);
}

static int Fact(Obj context, Type *type_in_out, Obj *value_return)
{
  int n;
  BOA_TYPECHECK_GET(T_Int);
  TRY(Boa_StringGetInt(context, "n", &n));
  *value_return = Boa_Int_Create(fact(n));
  return TPM_OK;
}

main()
{
  Obj cp, context;
  int i, r;
  Boa_Startup();

  context = Boa_Create(T_Dict);
  cp = Boa_Create(T_ContextProc);
  Boa_ContextProc_Context(cp) = context;
  Boa_ContextProc_Func(cp) = Fact;
  Boa_StringSet(cp, "_args/n", '/'|BOA_INSERT, Boa_Int_Create(0));

  for(i=0;i<10;i++) {
    if(Boa_IntGetInt(cp, i, &r) != TPM_OK) {
      TpmPrependError("fact(%d)", i);
      TpmPrintError(stdout);
      continue;
    }
    printf("fact(%d) = %d\n", i, r);
  }
  Boa_Release(cp);

  Boa_Shutdown();
  exit(0);
}
