#include <boa/boa.h>

/* Modifies context. Returns nothing. */
static int Fib(Obj context, Type *type_in_out, Obj *value_return)
{
  Obj prev, cur;
  int i;
  TRY(Boa_StringGet(context, "prev", 0, &T_Int, &prev));
  TRY(Boa_StringGet(context, "cur", 0, &T_Int, &cur));
  /* integer mutation */
  i = Boa_Int_Value(prev) + Boa_Int_Value(cur);
  Boa_Int_Value(prev) = Boa_Int_Value(cur);
  Boa_Int_Value(cur) = i;
  return TPM_OK;
}

main()
{
  Obj cp, context;
  int i;
  Boa_Startup();

  context = Boa_Create(T_Dict);
  assert(Boa_StringSet(context, "prev", BOA_INSERT, Boa_Int_Create(0)) 
	 == TPM_OK);
  assert(Boa_StringSet(context, "cur", BOA_INSERT, Boa_Int_Create(1)) 
	 == TPM_OK);

  cp = Boa_Create(T_ContextProc);
  Boa_ContextProc_Context(cp) = context;
  Boa_ContextProc_Func(cp) = Fib;
  assert(Boa_StringSet(cp, "_args/dummy", '/'|BOA_INSERT, Boa_Int_Create(0)) 
	 == TPM_OK);

  for(i=0;i<10;i++) {
    Obj t;
    if(Boa_StringGet(context, "prev", 0, &T_Int, &t) != TPM_OK) {
      fprintf(stderr, "get prev failed\n");
      exit(1);
    }
    /* Boa_PrintNL(stdout, t); Boa_Release(t); */
    if(Boa_StringGet(context, "cur", 0, &T_Int, &t) != TPM_OK) {
      fprintf(stderr, "get cur failed\n");
      exit(1);
    }
    Boa_PrintNL(stdout, t); Boa_Release(t);
    if(Boa_StringGet(cp, "foo", 0, NULL, NULL) != TPM_OK) {
      TpmPrintError(stderr);
    }
  }
  Boa_Release(cp);

  Boa_Shutdown();
  exit(0);
}
