#include <boa/boa.h>

#define Err(str) fprintf(stderr, "--> %s\n", str)

main()
{
  Type at;
  Obj a, i;

  Boa_Startup();

  at = Boa_Type_Create("(tuple 3)");
  Boa_PrintNL(stdout, at);
  Boa_PrintNL(stdout, at->type);
  Boa_PrintNL(stdout, at->type->type);
  Boa_PrintNL(stdout, at->type->type->type);

  a = Boa_Create(at);
  Boa_Print(stdout, a); putchar('\n');
  i = Boa_Int_Create(7);
  if(Boa_IntSet(a, -1, BOA_REPLACE, i) == TPM_OK) {
    Err("set(-1) didn't fail");
  }
  if(Boa_IntSet(a, 3, BOA_REPLACE, i) == TPM_OK) {
    Err("set(3) didn't fail");
  }
  if(Boa_IntSet(a, 2, BOA_REPLACE, i) != TPM_OK) {
    Err("set(2) failed");
  }
  Boa_PrintNL(stdout, a);
  i = Boa_Int_Create(3);
  if(Boa_IntSet(a, 0, BOA_REPLACE, i) != TPM_OK) {
    Err("set(0) failed");
  }
  Boa_PrintNL(stdout, a);
  if(Boa_IntGet(a, 2, BOA_DELETE, &T_Int, &i) != TPM_OK) {
    Err("get(2) failed");
  }
  else {
    if(Boa_Int_Value(i) != 7) {
      Err("get(2) returned the wrong value");
      Boa_Release(i);
    }
  }
  Boa_PrintNL(stdout, a);

  Boa_Shutdown();
  exit(0);
}
