#include <boa/boa.h>

main()
{
  Obj t, formatter, file;
  Obj a;
  Obj format, dict_formatter;
  Type at;
  Boa_Startup();
  
  file = FileHandle_Open("-", "w");

  formatter = Boa_GetFormatter("boa");
  if(Boa_ObjSet(formatter, file, 0, Boa_Int_Create(7)) != TPM_OK) {
    fprintf(stderr, "formatter failed\n");
    exit(1);
  }
  if(Boa_ObjSet(formatter, file, 0, Boa_String_Create(strdup("hello"))) 
     != TPM_OK) {
    fprintf(stderr, "formatter failed\n");
    exit(1);
  }

  /* create an array */
  a = Boa_Create(Boa_Type_Create("(array 3 double)"));
  if(Boa_IntSet(a, 0, BOA_REPLACE, Boa_Double_Create(3)) != TPM_OK) {
    fprintf(stderr, "set(0) failed\n");
    exit(1);
  }
  Boa_IntSet(a, 1, BOA_REPLACE, Boa_Double_Create(6.7));
  Boa_IntSet(a, 2, BOA_REPLACE, Boa_Double_Create(-1));
  if(Boa_ObjSet(formatter, file, 0, a) != TPM_OK) {
    fprintf(stderr, "formatter failed\n");
    exit(1);
  }

  /* create an ord */
  a = Boa_Create(T_Ord);
  Boa_StringSet(a, "3", BOA_INSERT, Boa_String_Create(strdup("three")));
  Boa_StringSet(a, "two", BOA_INSERT, Boa_Double_Create(2));
  Boa_StringSet(a, "one", BOA_INSERT, Boa_Int_Create(1));

  dict_formatter = Boa_GetFormatter("dict");
#if 1
  /* tell it to format the ord with the dict formatter */
  if(Boa_StringGet(formatter, "_format", 0, NULL, &format) != TPM_OK) {
    fprintf(stderr, "no format setter\n");
    exit(1);
  }
  if(Boa_ObjSet(format, a, BOA_INSERT, Boa_String_Create("dict")) != TPM_OK) {
    fprintf(stderr, "format(a) = dict failed\n");
    exit(1);
  }
  Boa_Release(format);
#else
  Boa_Release(formatter);
  formatter = dict_formatter;
#endif

  /* output the ord */
  if(Boa_ObjSet(formatter, file, 0, a) != TPM_OK) {
    fprintf(stderr, "formatter failed\n");
    exit(1);
  }

  Boa_Release(file);
  Boa_Shutdown();
  exit(0);
}
