/* Abstraction decorator, with automatic currying.
 * An abstraction specifies "holes" in a context which must be filled in.
 * Holes may be filled by Set or Call.
 * When some of the holes are filled, a new abstraction is returned
 * for the rest (currying).
 * When all of the holes are filled, the _call attribute of the context,
 * which must be a pointer to a C function, is called with the context 
 * as argument.  If the holes were filled by a Call, 
 *
 * Holes are specified by an indexer
 */
#include <boa/boa.h>

/* Globals *******************************************************************/
Type T_Abstraction;
