/* Returns integers for string requests, and strings for integer requests. */
#include <boa/boa.h>

/* no data */

/* Globals *******************************************************************/
Type T_Atoi;

/* Functions *****************************************************************/

static int SPrint(Obj self, StrStream ss)
{
  return StrStreamPuts(ss, "anAtoi");
}

static int StringGet(Obj self, char *name, int flags,
		     Type *type_in_out, Obj *value_return)
{
  int i = atoi(name);
  if(!i && name[0] != '0') return TPM_BOTTOM;
  BOA_TYPECHECK_GET(T_Int);
  if(value_return) *value_return = Boa_Int_Create(i);
  return TPM_OK;
}
static int IntGet(Obj self, int index, int flags,
		  Type *type_in_out, Obj *value_return)
{
  char str[32];
  BOA_TYPECHECK_GET(T_String);
  sprintf(str, "%d", index);
  if(value_return) *value_return = Boa_String_Create(strdup(str));
  return TPM_OK;
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Err_Copy, Generic_Compare, Generic_Hash,
  StringGet, Err_StringSet,
  IntGet, Err_IntSet,
  Generic_ObjGet, Err_ObjSet
};

Obj Boa_Atoi_Define(void)
{
  T_Atoi = Boa_SimpleType_Create("atoi", &methods, 1, 1);
  return T_Atoi;
}
