#include <boa/boa.h>

/* Globals *******************************************************************/
Type T_Char;

/* Functions *****************************************************************/

Obj Boa_Char_Create(char c)
{
  Obj t = Boa_Create(T_Char);
  Boa_Char_Value(t) = c;
  return t;
}

static int SPrint(Obj self, StrStream ss)
{
  return StrStreamPutc(ss, *(char*)self->value);
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Generic_Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_Char_Define(void)
{
  T_Char = Boa_SimpleType_Create("char", &methods, sizeof(char), sizeof(char));
  return T_Char;
}
