/* Get(x) returns a cached, mapped version of x.
 * This is a temporary kludge until general abstraction mechanism exists.
 */
#include <boa/boa.h>

/* no data */

/* Globals *******************************************************************/
Type T_ConstructMap;

/* Functions *****************************************************************/

static int SPrint(Obj self, StrStream ss)
{
  return StrStreamPuts(ss, "aConstructMap");
}

static int ObjGet(Obj self, Obj index, int flags,
		  Type *type_in_out, Obj *value_return)
{
  BOA_TYPECHECK_GET(T_Merge);
  if(value_return) {
    Obj merge = Boa_Create(T_Merge);
    assert(Boa_StringSet(merge, "_/0", '/'|BOA_INSERT, 
			 Boa_Cache_Create(Boa_MapCon_Create(Boa_Hold(index))))
	   == TPM_OK);
    assert(Boa_StringSet(merge, "_/1", '/'|BOA_INSERT, Boa_Hold(index)) 
	   == TPM_OK);
    *value_return = merge;
  }
  return TPM_OK;
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Err_Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  ObjGet, Err_ObjSet
};

Obj Boa_ConstructMap_Define(void)
{
  T_ConstructMap = Boa_SimpleType_Create("constructMap", &methods, 1, 1);
  return T_ConstructMap;
}
