#include <boa/boa.h>

/* Globals *******************************************************************/
Type T_Double;

/* Functions *****************************************************************/

Obj Boa_Double_Create(double d)
{
  Obj t = Boa_Create(T_Double);
  Boa_Double_Value(t) = d;
  return t;
}

static int SPrint(Obj self, StrStream ss)
{
  return StrStreamPutDouble(ss, Boa_Double_Value(self));
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Generic_Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_Double_Define(void)
{
  T_Double = Boa_SimpleType_Create("double", &methods, 
				   sizeof(double), sizeof(double));
  return T_Double;
}
