#include <boa/boa.h>

/* Globals *******************************************************************/
Type T_Float;
static Obj Float0, Float1, FloatM1;

/* Functions *****************************************************************/

Obj Boa_Float_Create(float f)
{
  Obj t;
  if(f == 0) return Boa_Hold(Float0);
  if(f == 1) return Boa_Hold(Float1);
  if(f == -1) return Boa_Hold(FloatM1);
  t = Boa_Create(T_Float);
  Boa_Float_Value(t) = f;
  return t;
}

static int SPrint(Obj self, StrStream ss)
{
  return StrStreamPutDouble(ss, (double)Boa_Float_Value(self));
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Generic_Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_Float_Define(void)
{
  T_Float = Boa_SimpleType_Create("float", &methods, 
				  sizeof(float), sizeof(float));
  /* Cache some commonly used numbers */
  Float0 = Boa_Create(T_Float);
  Boa_Float_Value(Float0) = 0;
  Float1 = Boa_Create(T_Float);
  Boa_Float_Value(Float1) = 1;
  FloatM1 = Boa_Create(T_Float);
  Boa_Float_Value(FloatM1) = -1;
  return T_Float;
}
