/* Answers integer requests with the same integer plus a constant. */
#include <boa/boa.h>

typedef struct Offset {
  int offset;
} *Offset;

/* Globals *******************************************************************/
Type T_Offset;

/* Functions *****************************************************************/

static int SPrint(Obj self, StrStream ss)
{
  Offset offset = (Offset)self->value;
  StrStreamPuts(ss, "offset(");
  StrStreamPutInt(ss, offset->offset);
  return StrStreamPutc(ss, ')');
}

static int StringSet(Obj self, char *name, int flags, Obj value)
{
  Offset offset = (Offset)self->value;
  if(name[0] == '_') {
    if(!strcmp(name+1, "offset")) {
      if(value->type != T_Int) return TPM_BOTTOM;
      offset->offset = Boa_Int_Value(value);
      Boa_Release(value);
      return TPM_OK;
    }
  }
  return TPM_BOTTOM;
}

static int IntGet(Obj self, int index, int flags,
		  Type *type_in_out, Obj *value_return)
{
  Offset offset = (Offset)self->value;
  BOA_TYPECHECK_GET(T_Int);
  if(value_return) *value_return = Boa_Int_Create(index + offset->offset);
  return TPM_OK;
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Err_Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, StringSet,
  IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_Offset_Define(void)
{
  T_Offset = Boa_SimpleType_Create("offset", &methods, 
				   sizeof(struct Offset), sizeof(int));
  return T_Offset;
}
