/* Holds a pointer to an opaque data structure.
 * User must handle the memory management of this structure.
 * Requires: SimpleType.
 */
#include <boa/boa.h>

/* Globals *******************************************************************/
Type T_Ptr;

/* Functions *****************************************************************/

Obj Boa_Ptr_Create(Ptr p)
{
  Obj t = Boa_Create(T_Ptr);
  Boa_Ptr_Value(t) = p;
  return t;
}

static int SPrint(Obj self, StrStream ss)
{
  return StrStreamPutInt(ss, (int)*(Ptr*)self->value);
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Generic_Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_Ptr_Define(void)
{
  T_Ptr = Boa_SimpleType_Create("ptr", &methods, sizeof(Ptr), sizeof(Ptr));
  return T_Ptr;
}
