#include <boa/boa.h>

/* Globals *******************************************************************/
Type T_String;

/* Functions *****************************************************************/

Obj Boa_String_Create(char *s)
{
  Obj t = Boa_Create(T_String);
  free(Boa_String_Value(t));
  Boa_String_Value(t) = s;
  return t;
}

Obj Boa_String_00(char **s)
{
  Obj t = Boa_CreateFromData(T_String, NULL);
  t->value = s;
  return t;
}

Obj Boa_String_01(char *s)
{
  Obj t = Boa_CreateFromData(T_String, Allocate(1, char*));
  Boa_String_Value(t) = s;
  BoaFreeAND01(t);
  return t;
}

static void Init(Obj self)
{
  Boa_String_Value(self) = strdup("");
}

static int SPrint(Obj self, StrStream ss)
{
  StrStreamPutc(ss, '"');
  StrStreamPuts(ss, Boa_String_Value(self));
  return StrStreamPutc(ss, '"');
}

static int Copy(Obj self, Ptr value_return)
{
  *(char**)value_return = strdup(Boa_String_Value(self));
  return TPM_OK;
}

static int Compare(Obj a, Obj b)
{
#if 1
  static int ctr = 0;
  if(ctr++ % 1000 == 0) fprintf(stderr, "strcmp %d\n", ctr);
#endif
  return strcmp(Boa_String_Value(a), Boa_String_Value(b));
}

static int Hash(Obj self)
{
  return HashString(Boa_String_Value(self));
}

static struct Boa_Methods methods = {
  Init, Generic_Final, Empty_Clean,
  SPrint, Copy, Compare, Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_String_Define(void)
{
  T_String = Boa_SimpleType_Create("string", &methods, 
				   sizeof(char*), sizeof(char*));
  return T_String;
}
