/* The SimpleType type. 
 * Requires: nothing.
 */
#include <boa/boa.h>

/* Globals *******************************************************************/
Type T_SimpleType;

/* Functions *****************************************************************/

/* Convenience function for creating a SimpleType */
Type Boa_SimpleType_Create(char *name, Boa_Methods methods, 
			   int size, int align)
{
  Type t = Boa_Create(T_SimpleType);
  TypeName(t) = name;
  TypeMethods(t) = methods;
  TypeSize(t) = size;
  TypeAlign(t) = align;
  return t;
}

static int SPrint(Obj self, StrStream ss)
{
  Boa_SimpleType data = (Boa_SimpleType)self->value;
  return StrStreamPuts(ss, data->name);
}

static int StringGet(Obj self, char *name, int flags,
		     Type *type_in_out, Obj *value_return)
{
  return TPM_BOTTOM;
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Generic_Copy, Identity_Compare, Generic_Hash,
  StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_SimpleType_Define(void)
{
  Boa_SimpleType data = Allocate(1, struct Boa_SimpleType);
  data->methods = &methods;
  data->size = sizeof(struct Boa_SimpleType);
  data->align = sizeof(Ptr);
  data->name = "stype";

  /* SimpleType has itself as type */
  T_SimpleType = Boa_CreateFromData(NULL, data);
  T_SimpleType->type = T_SimpleType;
  return T_SimpleType;
}
