#include <boa/boa.h>
#include <boa/vector.h>

/* Globals *******************************************************************/
Type T_Vector = NULL;

/* Functions *****************************************************************/

Obj Boa_Vector_Create(Vector v)
{
  Obj t = Boa_Create(T_Vector);
  Boa_Vector_Value(t) = v;
  return t;
}

static void Final(Obj self)
{
  if(Boa_Vector_Value(self)) VectorFree(Boa_Vector_Value(self));
}

/* prints like an array */
static int SPrint(Obj self, StrStream ss)
{
  StrStreamPutc(ss, '{');
  if(Boa_Vector_Value(self)) {
    Vector v = Boa_Vector_Value(self);
    int i;
    for(i=0;i<v->len;i++) {
      StrStreamPutDouble(ss, v->d[i]);
      StrStreamPutc(ss, ' ');
    }
  }
  return StrStreamPutc(ss, '}');
}

static int Copy(Obj self, Ptr value_return)
{
  *(Vector*)value_return = VectorCopy(Boa_Vector_Value(self));
  return TPM_OK;
}

static struct Boa_Methods methods = {
  Empty_Init, Final, Empty_Clean,
  SPrint, Copy, Generic_Compare, Generic_Hash,
  Err_StringGet, Err_StringSet,
  Err_IntGet, Err_IntSet,
  Generic_ObjGet, Generic_ObjSet
};

Obj Boa_Vector_Define(void)
{
  T_Vector = Boa_SimpleType_Create("vector", &methods, 
				   sizeof(Vector), sizeof(Ptr));
  return T_Vector;
}
