#ifndef MNM_H_INCLUDED
#define MNM_H_INCLUDED

#include <tpm/matrix.h>

typedef struct MultinomialMixture {
  /* Each row of center is the mean for a mixture component. */
  Matrix center;

  /* Mixing proportions */
  Vector prior;

  double temperature;

} *MultinomialMixture;

MultinomialMixture MultinomialMixtureCreate(int ncenters, int ndims);
void MultinomialMixtureFree(MultinomialMixture dm);
double MultinomialMixtureClassify(MultinomialMixture dm, Vector point, 
				double *mbr);

double MultinomialMixtureTrainEM(MultinomialMixture dm, Matrix points);
double MultinomialMixtureTrainStepE(MultinomialMixture dm, Matrix points, 
				  Matrix mbr);
void MultinomialMixtureTrainStepM(MultinomialMixture dm, Matrix points, 
				Matrix mbr);
void MultinomialMixtureTrainStepP(MultinomialMixture dm, Matrix mbr);

#endif
