#include <tpm/stream.h>
#include "mnm.h"

void main()
{
  MultinomialMixture dm = MultinomialMixtureCreate(2, 3);
  Matrix m, points;
  Vector v;
  FileHandle h;
  int i;

#if 0
  h = FileOpen("test_mnm.center", "r");
  m = MatrixScan(h);
  MatrixMove(dm->center, m);
  MatrixFree(m);
  FileClose(h);

  /* Extract samples */
  points = MatrixCreate(100*dm->center->rows, dm->center->cols);
  v = VectorFromData(dm->center->cols, NULL);
  for(i=0;i<points->rows;i++) {
    v->d = points->d2[i];
    MultinomialMixtureSample(dm, v);
  }
  free(v);
  /* MatrixPrint(stdout, points); */
#else
  h = FileOpen("test_mnm.points", "r");
  points = MatrixScan(h);
  FileClose(h);
#endif

  /* Now fit the samples */
  MultinomialMixtureTrainEM(dm, points);
  dm->temperature = 0.1;
  MultinomialMixtureTrainEM(dm, points);
  dm->temperature = 0.01;
  MultinomialMixtureTrainEM(dm, points);
  fprintf(stderr, "center:\n");
  MatrixPrint(stderr, dm->center);
  fprintf(stderr, "prior:\n");
  VectorPrint(stderr, dm->prior);
  
  MatrixFree(points);
  MultinomialMixtureFree(dm);
  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
