pointcanvas .c -background black -width 400 -height 400
pack .c -fill both -expand 1

label .info -text "Left button places a point   Middle button drags a point   Right button removes a point"
pack .info -fill x -expand 1

button .mst -text "Minimum Spanning Tree" -command {
    set points [pointcanvas_points .c]

    # convert the list into separate lines
    set string ""
    foreach pt $points {
	append string "$pt\n"
    }

    # call matrix_mst
    set tree [exec $env(PKG)/cluster/bin/$env(MACHTYPE)/matrix_mst -ascii << $string 2> /dev/null]

    # split result into a list
    set tree [split $tree "\n"]

    # discard first line
    set tree [lrange $tree 1 end]

    drawSpanTree $tree $points
}
pack .mst -fill x

button .quit -text Quit -command exit
pack .quit -fill x

proc drawSpanTree {tree points} {
    # clear the canvas of lines and text
    eval .c delete [.c find withtag line] [.c find withtag text]

    set i 0
    foreach node $tree {
	unpack $node dummy parent edge
	set pt [lindex $points $i]
	incr i
	if {$parent >= 0} {
	    set ppt [lindex $points $parent]

	    # draw a line from this node to its parent
	    eval .c create line $pt $ppt -fill white -tags line

	    # find the midpoint
	    set mx [expr ([lindex $pt 0] + [lindex $ppt 0])/2]
	    set my [expr ([lindex $pt 1] + [lindex $ppt 1])/2]
	    .c create text $mx $my -text $edge -fill white -tags text
	}   
    }
}
