#include <tpm/tpm.h>
#include <tpm/matrix.h>
#include <gl/image.h>
#include <tpm/image.h>

#define HSV 1

TpmImage TpmReadAny(char *fname)
{
  TpmImage image;
  image = TpmReadPnm(fname);
  if(image) return image;
  image = TpmReadSgi(fname);
  if(image) return image;
  image = TpmReadJpeg(fname);
  if(image) return image;
  image = TpmReadTiff(fname);
  if(image) return image;
  return image;
}

/* Reads image names on stdin and outputs autocorrelograms on stdout. */
void main()
{
  int spacing[] = { 1, 3, 5, 7 };
  Matrix result = MatrixCreate(64, 4);
  char fname[1024];
  TpmImage image, rgb_image;
  for(;;) {
    if(gets(fname) == NULL) break;
    rgb_image = TpmReadAny(fname);
    if(!rgb_image) {
      fprintf(stderr, "Cannot open `%s': \n", fname);
      perror("");
      continue;
    }
#if HSV
    TpmImageRGB2HSV(rgb_image);
#endif
    image = TpmImageQuantizeCube(rgb_image, 4, 4, 4);
    if(0) {
      int i;
      for(i=0;i<20;i++) {
	fprintf(stderr, "%d ", image->d2[5][i]);
      }
      fprintf(stderr, "\n");
      for(i=0;i<20;i++) {
	fprintf(stderr, "(%d, %d, %d) ", 
		rgb_image->d3[0][5][i],
		rgb_image->d3[1][5][i],
		rgb_image->d3[2][5][i]);
      }
      fprintf(stderr, "\n");
    }
    TpmImageFree(rgb_image);
    TpmImageAutoCorrelogram(image, spacing, result);
    TpmImageFree(image);
    printf("%s ", fname);
#if 0
    MatrixPrint(stdout, result);
#else
    VectorPrintNL(stdout, (Vector)result);
#endif
  }
  MatrixFree(result);
  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
