#include <boa/boa.h>
#include <tpm/boa_learn.h>
#include "hier.h"

int main(int argc, char *argv[])
{
  Obj od, featureMap, features, classifier;
  Obj instance, t;
  int i;
  char line[256];

  if(argc < 2) {
    fprintf(stderr, "usage: boa_test hier hier ...\n");
    exit(1);
  }
  Boa_Startup();
  Boa_Hier_Pkg();
  Boa_Learn_Pkg();
  Boa_Tcl_Pkg();

   /* read trees */
  features = Boa_Create(T_Ord);
  od = Boa_Create(T_ObjDir);
  for(i=1;i<argc;i++) {
    if(Boa_StringGet(od, argv[i], 0, NULL, &t) != TPM_OK) {
      TpmPrependError("Cannot load tree `%s'", argv[i]);
      TpmPrintError(stderr);
      exit(1);
    }
    Boa_StringSet(features, argv[i], BOA_INSERT, t);
  }
  Boa_Release(od);

  classifier = Boa_Classifier_Create(NULL, features, IntCmp, NULL);

  /* instance will track i */
  instance = Boa_CreateFromData(T_Int, NULL);
  instance->value = &i;

  printf("enter examples in the form:\n  item weight\n");
  for(;;) {
    float weight;

    gets(line);
    if(!line[0]) break;
    sscanf(line, "%d %f", &i, &weight);

    Boa_ObjSet(classifier, instance, BOA_INSERT, Boa_Float_Create(weight));

    /* loop integers and display their class */
    for(i=0;i<10;i++) {
      if(Boa_ObjGet(classifier, instance, 0, &T_Float, &t) == TPM_OK) {
	weight = Boa_Float_Value(t);
	Boa_Release(t);
	if(weight != 0) printf("  %d %f\n", i, weight);
      }
    }
  }
  Boa_Release(instance);
  Boa_Release(classifier);

  Boa_Shutdown();
  exit(0);
}
