#include <tpm/tree.h>
#include <tpm/hier.h>

void main(int argc, char *argv[])
{
  int i;
  FILE *h;
  Tree tree;
  Hier hier;

  if(argc > 2) {
    fprintf(stderr, "usage: hier2tree < tree > hier\n");
    exit(1);
  }
  hier = HierCreateFromFile("-");
  if(!hier) {
    fprintf(stderr, "bad hier\n");
    exit(1);
  }
  tree = TreeFromHier(hier);
  HierFree(hier);
  TreeWrite(stdout, tree, IntWrite);
  TreeFree(tree, GenericFree);

  MEM_BLOCKS();
  MEM_STATUS();
}
