typedef struct Leaf {
  int tree, node;
} *Leaf;

typedef struct Example {
  List leaves; /* contains Leaf */
  float weight;
  char mark;
} *Example;

/* A Cover covers all nodes between cover->node and cover->high, inclusive. */
typedef struct Cover {
  int tree, node;
  int high; /* index of first leaf */
} *Cover;

#define CoverFree GenericFree
#define LeafFree GenericFree
#define ExampleFree GenericFree

List LearnWithClassMatchingGeneric(LearnHandle lh, int class, 
				   void *item, CmpFunc *compare);
void LearnMarkCovered(LearnHandle lh, int class, Cover cover);
void LearnExampleFree(Example ex);
void AddEx(LearnHandle lh, int class, List leaves, float weight);
LearnHandle LearnSaveState(LearnHandle lh, int class);
void LearnClearState(LearnHandle lh, int class);
void LearnRestoreState(LearnHandle lh, int class, LearnHandle save);

/* Defined by the child */
void *LearnClassDataInit(int class);
void LearnClassDataFree(void *covers);
void LearnClassDataPrint(LearnHandle lh, int class, FILE *fp);
