#include "learn.h"

void main(int argc, char *argv[])
{
  LearnHandle lh;
  int i;
  char line[256];

  MEM_ABORT_ON_ERROR(2);
  if(argc < 2) {
    fprintf(stderr, "usage: test hier hier ...\n");
    exit(1);
  }
  lh = LearnInit();
  for(i=0;i<argc-1;i++) {
    char *fname = argv[i+1];
    Hier tree = HierCreateFromFile(fname);
    if(!tree) {
      fprintf(stderr, "Error reading `%s'\n", fname);
      continue;
    }
    LearnAddTree(lh, tree);
    sprintf(line, "%s.bias", fname);
    if(LearnReadBias(lh, i, line)) printf("no bias\n");
  }

  printf("enter examples in the form:\n  class item weight\n");
  for(;;) {
    int class, item;
    float weight;
    List items;

    gets(line);
    if(!line[0]) break;
    sscanf(line, "%d %d %f", &class, &item, &weight);
    while(class >= lh->nclasses) LearnAddClass(lh);
    LearnAddEx(lh, class, weight, &item, IntCmp);
    LearnUpdate(lh);

    printf("class %d:\n", class);
    items = LearnWithClass(lh, class);
    {int *ip;ListIter(p, ip, items) {
      printf("  %d\n", *ip);
    }}
    ListFree(items);
  }
  LearnFreeTrees(lh);
  LearnFree(lh);

  MEM_BLOCKS();
  MEM_STATUS();
}
