/* Output is always the average of the values put in.
 * Keys are ignored.
 */
#include <boa/boa.h>

typedef struct Average {
  float sum;
  int count;
} *Average;

/* Globals *******************************************************************/
Type T_Average;

/* Functions *****************************************************************/

static int SPrint(Obj self, StrStream ss)
{
  Average a = (Average)self->value;
  StrStreamPuts(ss, "average(");
  StrStreamPutDouble(ss, a->sum);
  return StrStreamPutc(ss, ')');
}

static int ObjGet(Obj self, Obj index, int flags,
		  Type *type_in_out, Obj *value_return)
{
  Average a = (Average)self->value;

  BOA_TYPECHECK_GET(T_Float);
  if(value_return) *value_return = Boa_Float_Create(a->sum/a->count);
  return TPM_OK;
}

static int ObjSet(Obj self, Obj index, int flags, Obj value)
{
  Average a = (Average)self->value;
  if(value->type == T_Float) {
    a->sum += Boa_Float_Value(value);
  }
  else return TPM_BOTTOM;
  a->count++;
  return TPM_OK;
}

static struct Boa_Methods methods = {
  Empty_Init, Empty_Final, Empty_Clean,
  SPrint, Err_Copy, Generic_Compare, Generic_Hash,
  Generic_StringGet, Generic_StringSet,
  Err_IntGet, Err_IntSet,
  ObjGet, ObjSet
};

Obj Boa_Average_Define(void)
{
  T_Average = Boa_SimpleType_Create("average", &methods, 
				    sizeof(struct Average), 
				    sizeof(Obj));
  return T_Average;
}
