#include <tpm/tree.h>
#include <tpm/hier.h>

void main(int argc, char *argv[])
{
  int i;
  FILE *h;
  Tree tree;
  Hier hier;

  if(argc > 2) {
    fprintf(stderr, "usage: tree2hier < tree > hier\n");
    exit(1);
  }
  tree = TreeRead(stdin, IntRead);
  hier = HierCreate(TreeSize(tree), sizeof(int));
  HierFromTree(hier, tree);
  TreeFree(tree, GenericFree);
  HierWrite(hier, stdout);
  HierFree(hier);

  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
