#include <time.h>
#include <tpm/tpm.h>
#include "matrix.h"

void main()
{
  Matrix A, T, U;
  Vector V;
  int i;
  if(0) {
    time_t start;
    /* invert a large random matrix */
    A = MatrixCreate(1000, 1000);
    VectorApply((Vector)A, (MathFunc*)Rand);
    printf("inverting %d by %d matrix...\n", A->rows, A->cols);
    start = time(NULL);
    MatrixInvert(A);
    printf("done (%d sec)\n", time(NULL)-start);
    MatrixFree(A);
  }
  if(1) {
    time_t start;
    /* square a large random matrix */
    A = MatrixCreate(1000, 1000);
    VectorApply((Vector)A, (MathFunc*)Rand);
    T = MatrixCreate(A->rows, A->cols);
    U = MatrixCreate(A->rows, A->cols);
    printf("squaring %d by %d matrix...\n", A->rows, A->cols);
    start = time(NULL);
    MatrixMultiply(T, A, A);
    printf("done (%d sec)\n", time(NULL)-start);

    printf("squaring %d by %d matrix...\n", A->rows, A->cols);
    start = time(NULL);
    MatrixMultiply_Slow(U, A, A);
    printf("done (%d sec)\n", time(NULL)-start);
    /* check */
    if(VectorCompare((Vector)U, (Vector)T)) {
      for(i=0;i<10;i++) {
	printf("U[%d] = %g\tT[%d] = %g\n", i, U->d[i], i, T->d[i]);
      }
    }
    MatrixFree(U);
    MatrixFree(T);
    MatrixFree(A);
  }
  if(0) {
    time_t start;
    /* square a large random matrix */
    A = MatrixCreate(2000, 2000);
    VectorApply((Vector)A, (MathFunc*)Rand);
    V = VectorCreate(A->cols);
    VectorApply(V, (MathFunc*)Rand);
    printf("matrix-vector multiply (%d by %d)...\n", A->rows, A->cols);
    start = time(NULL);
    for(i=0;i<100;i++) {
      MatrixVectorMultiply(V, A, V);
    }
    printf("done (%d sec)\n", time(NULL)-start);

    VectorApply(V, (MathFunc*)Rand);
    printf("matrix-vector multiply (%d by %d)...\n", A->rows, A->cols);
    start = time(NULL);
    for(i=0;i<100;i++) {
      MatrixVectorMultiply_Slow(V, A, V);
    }
    printf("done (%d sec)\n", time(NULL)-start);
    VectorFree(V);
    MatrixFree(A);
  }
  exit(0);
}
