#ifndef MATRIXSPARSEP_H_INCLUDED
#define MATRIXSPARSEP_H_INCLUDED

typedef struct MatrixSparsePRec {
  void **d;  /* [len] */
  int len;
  int cols;
  int *col; /* [len] */
  int rows;
  int *start; /* [rows+1] start of each row in col array. */
  int *end;   /* [rows+1] end of each row in col array. */
  int size; /* size of d/col buffers */
} *MatrixSparseP;

#define MatrixSparsePAt(m, r, c) m->d[MatrixSparsePIndex(m, r, c)]

MatrixSparseP MatrixSparsePCreate(int rows, int cols);
void MatrixSparsePFree(MatrixSparseP m);
int MatrixSparsePIndex(MatrixSparseP m, int r, int c);
void MatrixSparsePDelete(MatrixSparseP m, int r, int c);
void MatrixSparsePInsert(MatrixSparseP m, int r, int c, void *value);

#endif
