/* Slow simulation of mlapack routines, without using LAPACK. */

#include <math.h>
#include "matrix.h"
#include <tpm/tpm.h>

/* Prototypes ****************************************************************/

void MatrixMultiply(Matrix dest, Matrix A, Matrix B);
void MatrixTransposeTimesSelf(Matrix dest, Matrix A);
void MatrixSelfTimesTranspose(Matrix dest, Matrix A);
void MatrixVectorMultiply(Vector dest, Matrix A, Vector v);

/* Functions *****************************************************************/

void MatrixMultiply(Matrix dest, Matrix A, Matrix B)
{
  MatrixMultiply_Slow(dest, A, B);
}

void MatrixTransposeTimesSelf(Matrix dest, Matrix A)
{
  MatrixTransposeTimesSelf_Slow(dest, A);
}

void MatrixSelfTimesTranspose(Matrix dest, Matrix A)
{
  MatrixSelfTimesTranspose_Slow(dest, A);
}

void MatrixVectorMultiply(Vector dest, Matrix A, Vector v)
{
  MatrixVectorMultiply_Slow(dest, A, v);
}
