require matrix

set v [vector create 5]
puts "vector size: [vector size $v]"

vector set $v {10 20 30 40 50}
puts "vector at 4: [vector at $v 4]"
vector at $v 4 60
puts "vector at 4 60: [vector get $v]"

vector rescale $v 1 10
puts "vector rescale 1 10: [vector get $v]"
vector truncate $v 3 7
puts "vector truncate 3 7: [vector get $v]"
vector trunc_rescale $v 4 6 1 10
puts "vector trunc_rescale 4 6 1 10: [vector get $v]"
puts "vector sum: [vector sum $v]"

puts "vector maxk 4: [vector maxk $v 4]"

puts "samples:"
vector scale $v [expr 1.0/[vector sum $v]]
for {set i 0} {$i < 10} {incr i} {
    puts [vector sample $v]
}

vector fill $v 7
puts "vector fill 7: [vector get $v]"

vector free $v

puts ""

set m [matrix create 3 3]
puts "matrix size: [matrix size $m]"

vector fill $m 9
puts "vector fill 9: [matrix get $m]"

matrix set $m {1 2 3 4 5 6 7 8 9}
puts "matrix get: [matrix get $m]"
matrix at $m 2 2 10
puts "matrix at 2 2 10: [matrix at $m 2 2]"
puts [matrix get $m]
vector rescale $m 0 1
puts "vector rescale 0 1: [matrix get $m]"

matrix free $m
exit
