#include "optim.h"

/* f has minima at 1.096291202, -1.596291202 */
double f(double x)
{
  return x*x*x*x + x*x*x - 3.25*x*x - 1.75*x + 1.5;
}

main()
{
  double xmin, fmin;

  xmin = OptBrent(0, 2, (OptScalarFunc*)f, NULL, &fmin);
  assert(f(xmin) == fmin);
  printf("Brent(f, 0, 2) = %g at %g (should be 1.096291202)\n", fmin, xmin);

  xmin = OptBrent(-3, 0, (OptScalarFunc*)f, NULL, &fmin);
  assert(f(xmin) == fmin);
  printf("Brent(f, -3, 0) = %g at %g (should be -1.596291202)\n", fmin, xmin);

  /* minimum here is at the 1 endpoint */
  xmin = OptBrent(-1, 1, (OptScalarFunc*)f, NULL, &fmin);
  assert(f(xmin) == fmin);
  printf("Brent(f, -1, 1) = %g at %g (should be 1)\n", fmin, xmin);

  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
