#include <tpm/tpm.h>
#include "matrix.h"

main()
{
  Matrix A, S;
  Vector x;

  A = MatrixCreate(2,2);
  A->d2[0][0] = 14.0;
  A->d2[0][1] = 9.0;
  A->d2[1][0] = 9.0;
  A->d2[1][1] = 42.0;
  printf("A:\n");
  MatrixPrint(stdout, A);
  S = MatrixCopy(A);
  MatrixEvDecompose(S);
  printf("EvDecomp:\n");
  /* should be -3.2334 0.9497 ; 1.8829 6.4108 */
  MatrixPrint(stdout, S);
  MatrixEvCompose(S, A);
  printf("A:\n");
  MatrixPrint(stdout, A);
  
  x = VectorCreate(2);
  x->d[0] = 1;
  x->d[1] = 2;
  printf("x: %g %g\n", x->d[0], x->d[1]);
  /* should be 218 */
  printf("x'Ax = %g\n", MatrixEvQuad(S, x));
  VectorFree(x);

  MatrixEvInvert(S);
  MatrixEvCompose(S, A);
  printf("Invert(A):\n");
  /* should be  0.0828 -0.0178 ; -0.0178 0.0276 */
  MatrixPrint(stdout, A);

  MatrixEvPow(S, -1.5);
  MatrixEvCompose(S, A);
  printf("Pow(A, 1.5):\n");
  /* should be  58.9197 70.3027 ; 70.3027 277.6392 */
  MatrixPrint(stdout, A);

  MatrixFree(S);
  MatrixFree(A);
  
  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
