#include <tpm/tpm.h>
#include "vector.h"

main()
{
  Vector v1, v2;

  v1 = VectorCreate(5);

  VectorSet(v1, 7);
  printf("VectorSet(v1, 7): ");
  VectorPrintNL(stdout, v1);

  VectorAddValue(v1, 11);
  printf("VectorAddValue(v1, 11): ");
  VectorPrintNL(stdout, v1);

  VectorScale(v1, 0.5);
  printf("VectorScale(v1, 0.5): ");
  VectorPrintNL(stdout, v1);

  VectorApply(v1, (MathFunc*)sqrt);
  printf("VectorApply(v1, sqrt): ");
  VectorPrintNL(stdout, v1);

  printf("VectorSum(v1): %lg\n", VectorSum(v1));
  printf("VectorMag(v1): %lg\n", VectorMag(v1));

  v2 = VectorCreate(5);
  v2->d[0] = 0;
  v2->d[1] = 1;
  v2->d[2] = 2;
  v2->d[3] = 3;
  v2->d[4] = 4;
  printf("v2: ");
  VectorPrintNL(stdout, v2);
  VectorFlip(v2);
  printf("VectorFlip(v2): ");
  VectorPrintNL(stdout, v2);

  if(1) {
    int i;
    double best[3];
    VectorApply(v2, (MathFunc*)Rand);
    v2->d[0] = 1.0/0;
    v2->d[1] = 0.0/0;
    printf("v2: ");
    VectorPrintNL(stdout, v2);
    VectorMaximumK(v2, 3, best);
    printf("top %d:", 3);
    for(i=0;i<3;i++) {
      printf(" %g", best[i]);
    }
    printf("\n");
  }

  VectorFree(v1);
  VectorFree(v2);
  MEM_BLOCKS();
  MEM_STATUS();
}
