#ifndef BITSET_H_INCLUDED
#define BITSET_H_INCLUDED

typedef struct BitSet {
  unsigned char *mask;
  int length;   /* number of bytes in the mask */
} *BitSet;

BitSet BitSetCreate(int length);
void BitSetFree(BitSet s);
BitSet BitSetCopy(BitSet s);
void BitSetInsert(BitSet s, int i);
void BitSetDelete(BitSet s, int i);
int BitSetMember(BitSet s, int i);
int BitSetSize(BitSet s);
void BitSetUnion(BitSet result, BitSet s);
void BitSetIntersect(BitSet result, BitSet s);
void BitSetXor(BitSet result, BitSet s);

#endif
