/* Definitions for adjacency-list digraphs */
#ifndef DIGRAPH_H_INCLUDED
#define DIGRAPH_H_INCLUDED

#include <tpm/list.h>

/* DigraphNode structure (transparent) */
typedef struct DigraphNodeStruct {
  void *data;
  List edges;  /* List of DigraphEdges */
} *DigraphNode;

/* DigraphEdge structure (transparent) */
typedef struct DigraphEdgeStruct {
  void *data;
  DigraphNode to;
} *DigraphEdge;

typedef struct DigraphStruct {
  List nodes;        /* List of DigraphNodes */
  FreeFunc *nf, *ef; /* Node and Edge data free functions */
} *Digraph;

Digraph DigraphCreate(FreeFunc *nf, FreeFunc *ef);
void DigraphFree(Digraph dg);
DigraphNode DigraphAddNode(Digraph dg, void *data);
DigraphNode DigraphGetNode(Digraph dg, void *data, CmpFunc *cf);
void DigraphAddEdge(DigraphNode n1, DigraphNode n2, void *data);
void *DigraphGetEdge(DigraphNode n1, DigraphNode n2);
void DigraphReplaceEdge(Digraph dg, DigraphNode n1, DigraphNode n2, 
			void *data);

#endif
