#ifndef SPANTREE_H_INCLUDED
#define SPANTREE_H_INCLUDED

#include <tpm/tpm.h>

/* A SpanTree is a spanning tree over the numbers 0..num_nodes-1 */
typedef struct SpanTreeNode {
  float edge;  /* cost of the edge to parent */
  int parent;  /* -1 for the root */
} *SpanTreeNode;

typedef struct SpanTree {
  SpanTreeNode node; /* array of nodes */
  int num_nodes;
} *SpanTree;

/* spantree.c ****************************************************************/
SpanTree SpanTreeCreate(int num_nodes);
void SpanTreeFree(SpanTree st);
int SpanTreeRead(SpanTree st, FILE *h);
SpanTree SpanTreeCreateFromStream(FILE *h);
SpanTree SpanTreeCreateFromFile(char *file);
int SpanTreeWrite(SpanTree st, FILE *h);
int SpanTreePrint(FILE *h, SpanTree st);
void SpanTreeDistances(SpanTree st, int i, float *dist);

#endif
