#ifndef HEAP_H_INCLUDED
#define HEAP_H_INCLUDED

#include <tpm/tpm.h>

typedef void HeapIndexFunc(Any data, int index);

typedef struct Heap {
  Any *data;
  int length, bufsize;
  CmpFunc *cf;
  FreeFunc *ff;
  HeapIndexFunc *xf;
} *Heap;

#define HeapMin(heap) (heap)->data[0]
#define HeapIter(i, d, heap) \
  int i;for(i=0;(i < (heap)->length) && (d=(heap)->data[i],1);i++)

Heap HeapFromArray(Any *data, int length, CmpFunc *cf, FreeFunc *ff, 
		   HeapIndexFunc *xf);
Heap HeapCreate(CmpFunc *cf, FreeFunc *ff, HeapIndexFunc *xf);
void HeapFree(Heap heap);
void HeapDelete(Heap heap, int i);
void HeapDeleteNoFree(Heap heap, int i);
Any HeapExtractMin(Heap heap);
void HeapInsert(Heap heap, Any value);
void HeapChangedKey(Heap heap, int i);

#endif
