#include "isa.h"

/* Prototypes ****************************************************************/

IntStackArray IntStackArrayFromData(int *data, int len);
IntStackArray IntStackArrayCreate(int len);
void IntStackArrayAlmostFree(IntStackArray a);
void IntStackArrayFree(IntStackArray a);
void IntStackArrayPush(IntStackArray a, int index);
void IntStackArrayPop(IntStackArray a, int index);

/* Functions *****************************************************************/

IntStackArray IntStackArrayFromData(int *data, int len)
{
  IntStackArray a = Allocate(1, struct IntStackArray);
  a->data = data;
  a->stack = AllocateC(len, List);
  a->len = len;
  return a;
}

IntStackArray IntStackArrayCreate(int len)
{
  return IntStackArrayFromData(Allocate(len, int), len);
}

/* Does not free the data */
void IntStackArrayAlmostFree(IntStackArray a)
{
  int i;
  for(i=0;i<a->len;i++) if(a->stack[i]) ListFree(a->stack[i]);
  free(a->stack);
  free(a);
}

void IntStackArrayFree(IntStackArray a)
{
  free(a->data);
  IntStackArrayAlmostFree(a);
}

void IntStackArrayPush(IntStackArray a, int index)
{
  if(!a->stack[index]) a->stack[index] = ListCreate(NULL);
  ListAddFront(a->stack[index], (void*)a->data[index]);
}

void IntStackArrayPop(IntStackArray a, int index)
{
  a->data[index] = (int)ListFront(a->stack[index])->data;
  ListRemoveFront(a->stack[index], NULL);
}
