/* IntStackArray - an integer array whose elements can be stacked.
 * Operations:
 *   Elt(a, index) - integer lvalue
 *   Push(a, index) - saves the value at index
 *   Pop(a, index) - restores value before Push
 */

#include <tpm/list.h>

typedef struct IntStackArray {
  int *data;
  List *stack;
  int len;
} *IntStackArray;

#define IntStackArrayElt(a,i) (a)->data[i]

IntStackArray IntStackArrayFromData(int *data, int len);
IntStackArray IntStackArrayCreate(int len);
void IntStackArrayAlmostFree(IntStackArray a);
void IntStackArrayFree(IntStackArray a);
void IntStackArrayPush(IntStackArray a, int index);
void IntStackArrayPop(IntStackArray a, int index);
