#include <tpm/index.h>

typedef struct Tpm_Index_Entry {
  Any data;
  int left_count;
} *Tpm_Index_Entry;

typedef struct Tpm_Index {
  Tpm_Index_Entry heap;
  int length, bufsize;
  FreeFunc *ff;
} *Tpm_Index;

#define Parent(i) ((i)>>1)
#define Left(i) (2*(i)+1)
#define Right(i) (2*(i)+2)
#define IsLeft(i) ((i) & 1)

/* Prototypes ****************************************************************/

/* Functions *****************************************************************/

Tpm_Index Tpm_Index_Create(FreeFunc *ff)
{
  Tpm_Index index = Allocate(1, struct Tpm_Index);
  index->length = 0;
  index->bufsize = 16;
  index->heap = Allocate(index->bufsize, struct Tpm_Index_Entry);
  return index;
}

void Tpm_Index_Free(Tpm_Index index)
{
  if(index->ff) {
    int i;
    for(i=0;i<index->length;i++) index->ff(index->heap[i].data);
  }
  free(index->heap);
  free(index);
}

int Tpm_Index_Insert(Tpm_Index index, Any data)
{
  int i = index->length;
  index->length++;
  if(index->length >= index->bufsize) {
    index->bufsize *= 2;
    index->heap = Allocate(index->bufsize, struct Tpm_Index_Entry);
  }
  index->heap[i].data = data;
  index->heap[i].left_count = 0;
  for(;i;i=Parent(i)) {
    if(IsLeft(i)
    index->heap[i].left_count
  }
}

Tpm_Index_Delete
