/* Returns log2(n) for n=1,2,4,...,128. */
#define small_exact_log2(n)\
 ((uint)(05637042010L >> ((((n) % 11) - 1) * 3)) & 7)

/* Represent a fraction in [0.0..1.0]. */
/* Since undercolor removal requires a signed frac, */
/* we limit fracs to 15 bits rather than 16. */
typedef short frac;
typedef short signed_frac;
#define frac_bits (arch_sizeof_short * 8 - 1)
#define frac_0 ((frac)0)
#define frac_1 ((frac)0x7fff)
#define frac_1_long ((long)frac_1)
#define frac_1_float ((float)frac_1)
/* Conversion between fracs and floats */
#define frac2float(fr) ((fr) / frac_1_float)
#define float2frac(fl) ((frac)(((fl) + 0.5 / frac_1_float) * frac_1_float))
/* Conversion between fracs and bytes representing fractions */
#define frac2byte(fr) ((byte)((fr) >> (frac_bits - 8)))
#define byte2frac(b) ((frac)(((uint)(b) << (frac_bits - 8)) + ((b) >> (16 - frac_bits))))
