#include "polygon.h"
#include <tpm/tpm.h>

/* Prototypes ****************************************************************/

Tpm_Polygon *Tpm_PolygonCreate(void);
void Tpm_PolygonFree(Tpm_Polygon *poly);
void Tpm_PolygonAddPoint(Tpm_Polygon *poly, XPoint *p);
void Tpm_PolygonsFree(Tpm_Polygon **polys);

/* Functions *****************************************************************/

Tpm_Polygon *Tpm_PolygonCreate(void)
{
  Tpm_Polygon *poly = (Tpm_Polygon*)malloc(sizeof(Tpm_Polygon));
  poly->npoints = 0;
  return poly;
}

void Tpm_PolygonFree(Tpm_Polygon *poly)
{
  if(poly->npoints) free(poly->points);
  free(poly);
}

void Tpm_PolygonsFree(Tpm_Polygon **polys)
{
  Tpm_Polygon **p;
  for(p = polys; *p; p++) {
    Tpm_PolygonFree(*p);
  }
  free(polys);
}

void Tpm_PolygonAddPoint(Tpm_Polygon *poly, XPoint *p)
{
  if(poly->npoints == 0) poly->points = (XPoint*)malloc(1);
  poly->npoints++;
  poly->points = (XPoint*)realloc(poly->points, 
				  poly->npoints * sizeof(XPoint));
  poly->points[poly->npoints-1] = *p;
}
