require tpm

canvas .c -bg black
pack .c

image create photo
label .l -image image1
pack .l

# poly_points = current list of polygon vertices
# poly = polygon object drawn using poly_points
set color white

bind .c <1> {
    set x %x
    set y %y
    set poly_points [list $x $y $x $y]
    set poly [eval .c create line $poly_points -fill $color]
}

bind .c <B1-Motion> {
    # extend poly_points to include the picked point
    set pos [expr [llength $poly_points]-2]
    set poly_points [linsert $poly_points $pos %x %y]

    # redraw the polygon
    .c delete $poly
    if {$pos > 2} {
      # the "polygon" command will fill the object
      set poly [eval .c create polygon $poly_points -fill $color]
    } else {
      # make a line if only 2 points
      set poly [eval .c create line $poly_points -fill $color]
    }
}

bind .c <ButtonRelease-1> {
    set r [region fromPolygon $poly_points]
    puts "area: [region area $r]"
    puts "contains(100,100): [region contains $r 100 100]"
    set poly_points [region polygon $r]
    eval .c create line $poly_points -fill blue -width 5
    region free $r
}
