#include <tpm/cache.h>

#define NKEYS 10

char *Capitalize(char *s)
{
  char *r = strdup(s);
  char *p;
  for(p=r;*p;p++) {
    *p += 'A'-'a';
  }
  return r;
}

void main()
{
  Cache c;
  char **keys = Allocate(NKEYS, char*);
  char *s;
  int i,j;

  for(i=0;i<NKEYS;i++) {
    keys[i] = Allocate(2, char);
    keys[i][0] = i+'a';
    keys[i][1] = 0;
  }

  c = CacheCreate((CacheableFunc*)Capitalize, NULL, 
		  HashString, (CmpFunc*)strcmp,
		  StringCopy, StringCopy,
		  GenericFree, GenericFree, NKEYS/2);

  printf("sequential access:\n");
  for(i=0;i<2*NKEYS;i++) {
    s = CacheGet(keys[i % NKEYS], c);
    printf("%s -> %s\n", keys[i % NKEYS], s);
    free(s);
  }

  printf("random access:\n");
  for(j=0;j<2*NKEYS;j++) {
    i = RandInt(0, NKEYS-1);
    s = CacheGet(keys[i], c);
    printf("%s -> %s\n", keys[i], s);
    free(s);
  }

  CacheFree(c);
  for(i=0;i<NKEYS;i++) {
    free(keys[i]);
  }
  free(keys);

  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
