/* If libname is relative, it will be searched for using the LD_LIBRARY_PATH,
 * which may exclude the working directory.
 */

#include "tpm.h"
#include "dyn.h"

int foo(void)
{
  return 5;
}

int bar(int x)
{
  return 2*x;
}

void main(int argc, char *argv[])
{
  void *func;
  int result;

  if(argc < 3) {
    printf("usage: %s libname function_name [int_argument]\n", argv[0]);
    exit(1);
  }
  if(*argv[1] && !DynLoad(argv[1])) {
    perror("cannot load library");
    exit(1);
  }
  func = DynSymbol(NULL, argv[2]);
  if(!func) {
    printf("no such function\n");
    exit(1);
  }
  if(argc == 3) {
    result = ((int(*)(void))func)();
  }
  else if(argc == 4) {
    result = ((int(*)(int))func)(atoi(argv[3]));
  }
  printf("%d\n", result);
  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
