#include "tpm.h"

int g;

void work(void) {
  puts("work");
  if(g & 1) THROW(1, "work failed");
}
void cleanup(void) {
  puts("cleanup");
  if(g & 2) THROW(2, "cleanup failed");
}
void handle(void) {
  printf("Handled ");
  ErrorPrint(stdout);
  if(g & 4) THROW(4, "handle failed");
}

void doIt(void) {
  TRY {
    work();
  } CLEANUP {
    cleanup();
  } CATCH {
    handle();
    RETHROW;
  } END_TRY;
}

main()
{
  for(g=0;g<8;g++) {
    TRY {
      printf("\ng = %d\n", g);
      doIt();
    } CATCH {
      ErrorPrint(stdout);
    } END_TRY;
  }
  MEM_BLOCKS();
  MEM_STATUS();
}
