#include <tpm/heap.h>

typedef struct Test {
  int value;
  int index;
} *Test;

void HeapPrint(FILE *fp, Heap heap)
{
  int i;
  for(i=0;i<heap->length;i++)
    fprintf(fp, "(%d, %d) ", 
	    ((Test)heap->data[i])->value,
	    ((Test)heap->data[i])->index);
  fprintf(fp, "\n");
}

void HeapDump(Heap heap)
{
  for(;;) {
    Test t = (Test)HeapExtractMin(heap);
    if(!t) break;
    printf("%d ", t->value);
    free(t);
  }
  printf("\n");
}

void TestIndex(Test t, int index)
{
  t->index = index;
}

main()
{
  int i;
  Test *a;
  Heap heap;
  Test t;
  
  a = Allocate(16, Test);
  for(i=0;i<16;i++) {
    Test t = Allocate(1, struct Test);
    t->index = NAI;
    t->value = RandInt(1,16);
    a[i] = t;
  }
  heap = HeapFromArray((Any*)a, 16, IntCmp, GenericFree, 
		       (HeapIndexFunc*)TestIndex);
  HeapPrint(stdout, heap);
  
  HeapDelete(heap, 2);
  HeapPrint(stdout, heap);
  
  t = Allocate(1, struct Test);
  t->index = NAI;
  t->value = 22;
  HeapInsert(heap, t);
  HeapPrint(stdout, heap);
  
  t->value = 4;
  HeapChangedKey(heap, t->index);
  HeapPrint(stdout, heap);

  HeapDump(heap);
  HeapFree(heap);

  MEM_BLOCKS();
  MEM_STATUS();
}

