#include <tpm/index.h>

void main()
{
  Index ind = IndexCreate(HashString, (CmpFunc*)strcmp, GenericFree);
  if(IndexAtKey(ind, "foo") != NAI) {
    fprintf(stderr, "atKey(foo) didn't fail\n");
  }
  IndexInsert(ind, strdup("foo"));
  IndexInsert(ind, strdup("bar"));
  printf("atKey(bar) = %d, atIndex(1) = %s\n", 
	 IndexAtKey(ind, "bar"), IndexAtIndex(ind, 1));
  printf("atKey(foo) = %d, atIndex(0) = %s\n", 
	 IndexAtKey(ind, "foo"), IndexAtIndex(ind, 0));
  IndexPrint(stdout, ind);

  IndexDelete(ind, 0);
  IndexInsert(ind, strdup("baz"));
  printf("atKey(foo) = %d\n", IndexAtKey(ind, "foo"));
  printf("atKey(bar) = %d, atIndex(0) = %s\n", 
	 IndexAtKey(ind, "bar"), IndexAtIndex(ind, 0));
  printf("atKey(baz) = %d, atIndex(1) = %s\n", 
	 IndexAtKey(ind, "baz"), IndexAtIndex(ind, 1));

  IndexFree(ind);
  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
