#include <stdio.h>
#include <malloc.h>
#include "list.h"

void PtrWrite(FILE *fp, void *p)
{
  fprintf(fp, "%ld", (long)p);
}

void Show(List list)
{
  assert(list);
  printf("%d: ", ListSize(list));
  if(ListEmpty(list)) printf("<empty>");
  ListPrint(stdout, list, PtrWrite);
  printf("\n");
#if LIST_HAS_REAR
  if(ListRear(list)) printf("rear: %ld\n", (long)ListRear(list)->data);
#endif
}

void main(void)
{
  List l1,l2,l3;

  l1 = ListCreate(NULL);
  l3 = ListCreate(NULL);
  ListAddFront(l3, (void*)5);
  Show(l1);
  ListAddFront(l1, (void*)1);
  Show(l1);
  ListAddFront(l1, (void*)2);
  Show(l1);
  ListAddRear(l1, (void*)1);
  ListAddRear(l1, (void*)3);
  Show(l1);
  ListRemoveValue(l1, (void*)1, NULL);
  Show(l1);

  l2 = ListCreate(NULL);
  ListAddRear(l2, (void*)4);
  ListVaAppend(l1, l3, l2, NULL);
  Show(l1);
  ListRemoveAtIndex(l1, 0, NULL);
  Show(l1);
  ListRemoveFront(l1, NULL);
  Show(l1);
  ListRemoveRear(l1, NULL);
  Show(l1);
  ListRemoveAtIndex(l1, 1, NULL);
  Show(l1);
  ListFree(l1);

  l1 = ListCreate(NULL);
  ListAddFront(l1, (Any)1);
  ListAddFront(l1, (Any)2);
  ListAddFront(l1, (Any)3);
  ListAddFront(l1, (Any)4);
  ListAddFront(l1, (Any)5);
  printf("l1 ");
  Show(l1);
  ListShuffle(l1);
  printf("shuffled ");
  Show(l1);
  ListFree(l1);

  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}

