/* Simulates a stack and a queue using Lists. */
#include <tpm/list.h>

void main(void)
{
  double d, *dp;
  List stack, queue;

  /* We will store pointers to allocated doubles, which will be freed by
   * GenericFree().
   */
  stack = ListCreate(GenericFree);
  queue = ListCreate(GenericFree);

  printf("Please enter a list of doubles, separated by whitespace,\n");
  printf("terminated by a 0:\n");
  for(;;) {
    scanf("%lf", &d);
    if(!d) break;
    /* Allocate a block for the stack.
     * Could have used RealCreate(d) instead.
     */
    dp = Allocate(1, double);
    *dp = d;
    ListAddFront(stack, dp);
    /* Allocate a block for the queue */
    dp = Allocate(1, double);
    *dp = d;
    ListAddRear(queue, dp);
  }

  printf("Here they are in forward order:\n");
  {ListIter(p, dp, queue) {
    printf("%lg ", *dp);
  }}
  printf("\nHere they are in reverse order:\n");
  {ListIter(p, dp, stack) {
    printf("%lg ", *dp);
  }}
  printf("\n");

  ListFree(stack);
  ListFree(queue);
}
