/* Simulates a stack and a queue using Lists. */
#include <tpm/list.h>

void PtrWrite(FILE *fp, void *p)
{
  fprintf(fp, "%ld", (long)p);
}

void main(void)
{
  int i;
  List stack, queue;

  /* Since pointers are always big enough to hold ints, we will make
   * Lists of ints without needing to allocate/free any blocks.
   * Causes some compiler warnings, but what the hey.
   */
  stack = ListCreate(NULL);
  queue = ListCreate(NULL);

  printf("Please enter a list of integers, separated by whitespace,\n");
  printf("terminated by a 0:\n");
  for(;;) {
    scanf("%d", &i);
    if(!i) break;
    ListAddFront(stack, (Any)i);
    ListAddRear(queue, (Any)i);
  }

  printf("Here they are in forward order:\n");
  ListPrint(stdout, queue, PtrWrite);
  printf("\nHere they are in reverse order:\n");
  ListPrint(stdout, stack, PtrWrite);
  printf("\nHere they are in reverse order again:\n");
  ListReverse(queue);
  ListPrint(stdout, queue, PtrWrite);
  printf("\nHere they are shuffled:\n");
  ListShuffle(queue);
  ListPrint(stdout, queue, PtrWrite);
  printf("\nHere they are shuffled again:\n");
  ListShuffle(queue);
  ListPrint(stdout, queue, PtrWrite);
  printf("\n");

  ListFree(stack);
  ListFree(queue);
}
