/* Test of HashTable module. */

#include <tpm/hash.h>

void Statistics(HashTable ht);

/* This is the key_type passed to HashTableCreate */
#define HASHTYPE 2

void main(void)
{
  char s[100], *w;
  HashTable ht;
  int i, a[10];

  ht = HashTableCreate(HASHTYPE, NULL);
  for(;;) {
    printf("Enter key > ");
    gets(s);
    if(!s[0]) break;

#if HASHTYPE > 1
    w = strtok(s, " ");
    for(i=0;i<HASHTYPE;i++) {
      a[i] = atoi(w);
      w = strtok(NULL, " ");
    }
    HashTableAddEntry(ht, (HashKey)a, &i);
#elif HASHTYPE
    i = atoi(s);
    HashTableAddEntry(ht, (HashKey)i, &i);
#else
    HashTableAddEntry(ht, s, &i);
#endif

    if(i) printf("found\n");
    else Statistics(ht);
  }
  HashTableFree(ht);
  MEM_STATUS();
  MEM_BLOCKS();
}

#define NUM_COUNTERS 10
void Statistics(HashTable ht)
{
  int count[NUM_COUNTERS], i, j, overflow;
  double average;
  HashEntry *e;

  for(i=0;i<NUM_COUNTERS;i++) count[i] = 0;
  overflow = 0;
  average = 0.0;
  for(i=0;i<ht->num_buckets;i++) {
    j = 0;
    for(e=ht->buckets[i];e;e=e->next) j++;
    if(j < NUM_COUNTERS) count[j]++;
    else overflow++;
    average += (1.0+j)*j/ht->num_entries/2;
  }

  printf("%d entries, %d buckets\n", ht->num_entries, ht->num_buckets);
  for(i=0;i<NUM_COUNTERS;i++) {
    printf("%d buckets with %d entries\n", count[i], i);
  }
  printf("%d buckets with %d or more entries\n", overflow, NUM_COUNTERS);
  printf("average search distance: %.1f\n", average);
}
