#include <tpm/tpm.h>
#include "region.h"

int main(void)
{
  XPoint p;
  Tpm_Polygon *poly, *tp;
  int i,j;
  Tpm_Region *region;

  poly = Tpm_PolygonCreate();
  /* read poly points from stdin */
  for(;;) {
    if(scanf("%hd %hd", &p.x, &p.y) < 2) break;
    Tpm_PolygonAddPoint(poly, &p);
  }

  /* create a region */
  region = Tpm_RegionFromPolygon(poly);
  Tpm_PolygonFree(poly);

  {FILE *h = fopen("test_region.pgm", "w");
   Tpm_RegionWritePGM(h, region);
   fclose(h);}

  /* get the perimeter */
  poly = Tpm_RegionPolygon(region);

  /* write poly points */
  for(i=0;i<poly->npoints;i++) {
    printf("%d %d ", poly->points[i].x, poly->points[i].y);
  }
  printf("\n");

  Tpm_RegionFree(region);
  Tpm_PolygonFree(poly);
  MEM_BLOCKS();
  MEM_STATUS();
  exit(0);
}
