#include "tpm.h"
#include "strstream.h"

#define NOFAIL(e) if(e) { printf("%s failed", #e); exit(1); }
#define FAIL(e) if(!e) { printf("%s didn't fail", #e); exit(1); }

void main(void)
{
  StrStream ss;
  int i;
  char c;
  char *s;
  
  ss = StrStreamCreate(1, STRSTREAM_UNLIMITED);
  NOFAIL(StrStreamPutInt(ss, -5));
  NOFAIL(StrStreamPutc(ss, '*'));
  NOFAIL(StrStreamPuts(ss, "foo"));
  printf("ss(-5*foo): %s\n", StrStreamAsString(ss));
  StrStreamFree(ss);

  ss = StrStreamFromString("101;bar", 8, 0);
  NOFAIL(StrStreamGetInt(ss, &i));
  FAIL(StrStreamGetInt(ss, &i));
  NOFAIL(StrStreamGetc(ss, &c));
  NOFAIL(!(s = StrStreamGetWord(ss)));
  printf("i: %d\nc: %c\ns: %s\n", i, c, s);
  free(s);
  FAIL(!(s = StrStreamGetWord(ss)));
  FAIL(StrStreamPuts(ss, "longstring"));
  NOFAIL(StrStreamUnget(ss, 1));
  NOFAIL(StrStreamGetc(ss, &c));
  printf("last char: %c\n", c);
  StrStreamFree(ss);

  MEM_BLOCKS();
  MEM_STATUS();
}
