#include <tpm/gtree.h>

void ListWrite(FILE *fp, List list, WriteFunc *wf)
{
  ListNode p;
  ListIterate(p, list) {
    wf(fp, p->data);
    putchar(' ');
  }
  putchar('\n');
}

main()
{
  Tree a, b, c;
  List list;

  a = TreeCreate(IntCreate(1));
  TreeWrite(stdout, a, IntWrite); putchar('\n');

  b = TreeCreate(IntCreate(2));
  TreeAddSibling(b, TreeCreate(IntCreate(3)));
  TreeAddChild(b, TreeCreate(IntCreate(4)));
  TreeWrite(stdout, b, IntWrite); putchar('\n');

  TreeAddChild(a, b);
  TreeAddChild(a, TreeCreate(IntCreate(5)));
  TreeWrite(stdout, a, IntWrite); putchar('\n');

  printf("Size of a: %d\n", TreeSize(a));
  printf("# leaves: %d\n", TreeCountLeaves(a));
  printf("# non-leaves: %d\n", TreeCountNonLeaves(a));
  printf("Height of a: %d\n", TreeHeight(a));
  printf("Depth of b: %d\n", TreeDepth(b));
  printf("Leaf list: ");
  list = TreeLeafList(a);
  ListWrite(stdout, list, IntWrite);
  ListFree(list);

  printf("TreeSimplify removes %d nodes\n", TreeSimplify(a, GenericFree));
  TreeWrite(stdout, a, IntWrite); putchar('\n');

  TreeFree(a, GenericFree);
  MEM_BLOCKS();
  MEM_STATUS();
}
