/* Definitions for using Tries */
#ifndef TRIE_H_INCLUDED
#define TRIE_H_INCLUDED

#include <tpm/tpm.h>  /* for FreeFunc */

typedef struct Trie {
  char zero;
  struct Trie *link[27];
} *Trie;

typedef struct TrieEntry {
  char nonzero;
  char *key;
  void *data;
} *TrieEntry;

#define IsTrieEntry(t) ((t)->zero)
#define TrieKey(e) (((TrieEntry)e)->key)
#define TrieValue(e) (((TrieEntry)e)->data)

void TrieFree(Trie t, FreeFunc *ff);
Trie TrieAdd(Trie *tp, char *key, int *found);
Trie TrieFind(Trie t, char *key);

#endif
