#include <ph/photobook.h>

void main(int argc, char *argv[])
{
  Obj od, withins;
  char str[128];
  int total = 0;

  if(argc < 2) {
    fprintf(stderr, "usage: count_segments within < members\n");
    exit(1);
  }

  Boa_Startup();
  Boa_Hier_Pkg();
  Boa_Region_Pkg();
  Boa_Tcl_Pkg();    /* since disk objects may need it. grrr */

  od = Boa_Create(T_ObjDir);
  if(Boa_StringGet(od, argv[1], '/', NULL, &withins)) {
    ErrorPrepend("Cannot open within `%s'", argv[1]);
    ErrorPrint(stderr);
    exit(1);
  }

  /* loop members */
  for(;;) {
    int subtotal;
    Obj hierObj;
    int nwithin, i;
    WithinNode *within;
    char member[128];

    if(!gets(member)) break;

    /* read the hier */
    if(Boa_StringGet(withins, member, 0, NULL, &hierObj)) {
      ErrorPrepend("Cannot get hier for %s", member);
      ErrorPrint(stderr);
      continue;
    }
    nwithin = Boa_Hier_Length(hierObj->type);
    within = (WithinNode*)((Hier)hierObj->value)->node;

    subtotal = 0;
    for(i=0;i<nwithin;i++) {
      subtotal += SegSize(&within[i].seg);
    }
    printf("%s\t%d\n", member, subtotal);
    total += subtotal;
    Boa_Release(hierObj);
  }
  printf("Total\t%d\n", total);
  Boa_Release(withins);
  Boa_Release(od);

  Boa_Shutdown();
  exit(0);
} 

