/* read seg index
 * create output array
 * loop segs
 *   get from segMap
 *   put into array
 * write output
 */
#include <boa/boa.h>

Boa_DefineFunc Boa_SegMap_Define;

int main(int argc, char *argv[])
{
  Obj od, db, index, segMap, result;
  char str[128];
  int i, length;
  int *data;

  if(argc < 3) {
    fprintf(stderr, "usage: index2map db index\n");
    exit(1);
  }

  Boa_Startup();
  Boa_Tcl_Pkg();
  Boa_Hier_Pkg();
  Boa_Vector_Pkg();
  Boa_StringSet(Boa_Types, "segMap", BOA_INSERT, Boa_SegMap_Define());

  od = Boa_Create(T_ObjDir);
  if(Boa_StringGet(od, argv[2], '/', NULL, &index) != TPM_OK) {
    ErrorPrepend("Cannot read segment index");
    ErrorPrint(stderr);
    exit(1);
  }
  sprintf(str, "%s/%s", getenv("PHOTOBOOK_DB_DIR"), argv[1]);
  if(Boa_StringGet(od, str, '/', NULL, &db) != TPM_OK) {
    ErrorPrepend("Cannot open database");
    ErrorPrint(stderr);
    exit(1);
  }
  if(Boa_StringGet(db, "cache/segMap", '/', NULL, &segMap) != TPM_OK) {
    ErrorPrepend("Cannot read cache/segMap");
    ErrorPrint(stderr);
    exit(1);
  }
  Boa_Release(db);

  assert(Boa_StringGetInt(index, "_length", &length) == TPM_OK);
  sprintf(str, "(array %d (array 3 int))", length);
  result = Boa_Create(Boa_Type_Create(str));
  data = (int*)result->value;

  for(i=0;i<length;i++) {
    Obj name, t;
    assert(Boa_IntGet(index, i, 0, &T_String, &name) == TPM_OK);
    if(Boa_StringGet(segMap, Boa_String_Value(name), 0, NULL, &t) != TPM_OK) {
      ErrorPrint(stderr);
      exit(1);
    }
    if(i % 100 == 0) fprintf(stderr, "%s\n", Boa_String_Value(name));
    Boa_Release(name);
    Boa_Copy(t, &data[3*i]);
    Boa_Release(t);
  }
  Boa_StringSet(od, "-", 0, result);
  Boa_Release(segMap);
  Boa_Release(index);
  Boa_Release(od);

  Boa_Shutdown();
  exit(0);
}
