# <segment file> [image file]
if {$argc < 1} {puts "usage: <segment file> ?image file?"; exit}
set build "-mc"
load-libs tpm$build boa$build
load-libs region$build learn$build

catch boa
catch ph

canvas .canvas -height 512 -width 512
pack .canvas -expand 1 -fill both

frame .buttonf
pack .buttonf -expand 1 -fill x
button .up -text Up -command {
    if {$curseg > 0} {incr curseg -1} else {set curseg [expr $numsegs-1]}
    show_seg $curseg
}
button .down -text Down -command {
    if {$curseg < $numsegs-1} {incr curseg} else {set curseg 0}
    show_seg $curseg
}
entry .segnum
bind .segnum <Return> {
    set curseg [.segnum get]
    show_seg $curseg
}
pack .up .down -side left -in .buttonf
pack .segnum -expand 1 -fill x -side left -in .buttonf

set od [boa create [boa type objDir]]

# read the image, if given
if {$argc > 1} {
    set fname [lindex $argv 1]
    image create photo image1
    set im [boa get $od $fname]
    boa tk_image $im image1
    .canvas create image 0 0 -anchor nw -image image1
    .canvas configure -width [image width image1] -height [image height image1]
}

# read the seg file
set obj [boa get $od [lindex $argv 0]]
set numsegs [ph readsegs $obj segs]
boa free $obj
boa free $od

proc show_seg {seg} {
    global segs
    .segnum delete 0 end
    .segnum insert 0 $seg
    puts $segs($seg)
    .canvas delete line
    ph showseg .canvas $segs($seg) white
}

set curseg 0
show_seg $curseg
