/* Produces a segmentation hierarchy consisting of a simple tesselation. */

#include <ph/photobook.h>

int main(int argc, char *argv[])
{
  FILE *h;
  Seg seg;
  int i,j, x,y;
  int rows, cols;
  int xsize, ysize;

  if(argc < 3) {
    fprintf(stderr, "usage: tesselate rows cols\n");
    fprintf(stderr, "rows and cols must be powers of two <= 16\n");
    exit(1);
  }
  rows = atoi(argv[1]);
  ysize = 16/rows;
  cols = atoi(argv[2]);
  xsize = 16/cols;

  printf("hier %d (32 char)\n", rows*cols);
  for(i=0;i<rows;i++) {
    for(j=0;j<cols;j++) {
      int v = 0;
      AdjustBuffer(&v, 1, sizeof(int));
      fwrite(&v, sizeof(int), 1, stdout);
      v = -1; /* no parent */
      AdjustBuffer(&v, 1, sizeof(int));
      fwrite(&v, sizeof(int), 1, stdout);
      seg = SegZero;
      for(y=0;y<ysize;y++) {
	for(x=0;x<xsize;x++) {
	  SegSet(&seg, i*ysize + y, j*xsize + x);
	}
      }
      /* AdjustBuffer(&seg, 8, sizeof(int)); */
      fwrite(&seg, sizeof(char), 32, stdout);
    }
  }
  exit(0);
}
