#include <stdio.h>
#include <time.h>
#include <sys/stat.h>

int main(int argc, char *argv[])
{
  struct stat buf;
  if(argc < 2) { printf("usage: stat <file>\n"); exit(1); }
  if(stat(argv[1], &buf) == -1) { perror(argv[1]); exit(1); }
  printf("Device: %u\n", buf.st_dev);
  printf("Inode: %u\n", buf.st_ino);
  printf("Mode bits: %x\n", buf.st_mode);
  printf("File type: ");
  switch(buf.st_mode & S_IFMT) {
  case S_IFSOCK: printf("socket\n"); break;
  case S_IFLNK: printf("symbolic link\n"); break;
  case S_IFNWK: printf("network special\n"); break;
  case S_IFREG: printf("regular\n"); break;
  case S_IFBLK: printf("block special\n"); break;
  case S_IFDIR: printf("directory\n"); break;
  case S_IFCHR: printf("character special\n"); break;
  case S_IFIFO: printf("named pipe\n"); break;
  default: printf("unknown\n");
  }
  printf("Permission bits: %o\n", buf.st_basemode);
  printf("Number of links: %d\n", buf.st_nlink);
  printf("UID of owner: %d\n", buf.st_uid);
  printf("GID of owner: %d\n", buf.st_gid);
  printf("File size: %u\n", buf.st_size);
  printf("Time of last access       : %s", ctime(&buf.st_atime));
  printf("Time of last modification : %s", ctime(&buf.st_mtime));
  printf("Time of last status change: %s", ctime(&buf.st_ctime));
  exit(0);
}
