#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
  int fildes;
  int blocksize = 64*1024;
  char *buf;
  if(argc < 2) {
    fprintf(stderr, "Usage: tee_fifo <fifo>\n");
    fprintf(stderr, "to send blocks from stdin to stdout and <fifo>.\n");
    exit(1);
  }
  buf = (char*)malloc(blocksize);
  fildes = open(argv[1], O_WRONLY);
  for(;;) {
    int status = read(STDIN_FILENO, buf, blocksize);
    if(status == -1) {
      perror("read");
      exit(1);
    }
    else if(status == 0) break;
    else {
      write(STDOUT_FILENO, buf, status);
      write(fildes, buf, status);
    }
  }
  close(fildes);
  free(buf);
}
